/*
 * Copyright 2009 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for ECMAScript 5.
 * @see http://www.ecma-international.org/publications/files/drafts/tc39-2009-025.pdf
 * FROM_EXTERN
 */
@JsName()
library es5;

import 'package:js/js.dart';
import 'package:func/func.dart';

@JsName("ObjectPropertyDescriptor")
abstract class ObjectPropertyDescriptor {
// @Ignore
  external ObjectPropertyDescriptor.fakeConstructor$();

  /** @type {*} */
  dynamic value;

  /** @type {(function():?)||undefined} */
  Func0<dynamic> get;

  /** @type {(function(?):void)||undefined} */
  VoidFunc1<dynamic> set;

  /** @type {boolean|undefined} */
  bool writable;

  /** @type {boolean|undefined} */
  bool enumerable;

  /** @type {boolean|undefined} */
  bool configurable;
}

@JsName("JSONType")
abstract class JSONType {
// @Ignore
  external JSONType.fakeConstructor$();

  /**
   * @param {string} jsonStr The string to parse.
   * @param {(function(string, *) : *)=} opt_reviver
   * @return {*} The JSON object.
   * @throws {Error}
   * @nosideeffects
   */
  parse(String jsonStr, [opt_reviver(String arg1, arg2)]);

  /**
   * @param {*} jsonObj Input object.
   * @param {(Array.<string>|(function(string, *) : *)|null)=} opt_replacer
   * @param {(number|string)=} opt_space
   * @return {string} JSON string which represents jsonObj.
   * @throws {Error}
   * @nosideeffects
   */
  String stringify(jsonObj,
      [opt_replacer /*List<String>|null|Func2<String,dynamic,dynamic>|undefined*/,
      opt_space /*num|String|undefined*/]);
}
/**
 * @type {!JSONType}
 * @suppress {duplicate}
 */
@JsName("JSON")
external JSONType get JSON;
@JsName("JSON")
external set JSON(JSONType value);
