/*
 * Copyright 2008 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for all the extensions over
 *  W3C's DOM specification by Gecko. This file depends on
 *  w3c_dom2.js.
 *
 * When a non-standard extension appears in both Gecko and IE, we put
 * it in gecko_dom.js
 *
 * FROM_EXTERN
 */
@JsName()
library gecko_dom;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "es6.dart" as es6;

import "fileapi.dart" as fileapi;

import "ie_dom.dart" as ie_dom;

import "w3c_batterystatus.dart" as w3c_batterystatus;

import "w3c_css.dart" as w3c_css;

import "w3c_dom1.dart" as w3c_dom1;

import "w3c_dom2.dart" as w3c_dom2;

import "w3c_geolocation.dart" as w3c_geolocation;

import "w3c_range.dart" as w3c_range;

import "w3c_rtc.dart" as w3c_rtc;

import "w3c_serviceworker.dart" as w3c_serviceworker;

import "w3c_xml.dart" as w3c_xml;

/**
 * Mozilla only???
 * @constructor
 * @extends {HTMLElement}
 */
@JsName("HTMLSpanElement")
abstract class HTMLSpanElement extends w3c_dom2.HTMLElement {
// @Ignore
  external HTMLSpanElement.fakeConstructor$() : super.fakeConstructor$();
}

/** @constructor */
@JsName("Navigator")
abstract class Navigator {
// @Ignore
  external Navigator.fakeConstructor$();

  /**
   * @return {!Promise<!BatteryManager>}
   * @see http://www.w3.org/TR/battery-status/
   */
  es6.Promise<w3c_batterystatus.BatteryManager> getBattery();

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.appCodeName
   */
  String appCodeName;

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.appVersion
   */
  String appName;

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.appVersion
   */
  String appVersion;

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.buildID
   */
  String buildID;

  /**
   * @type {boolean}
   * @see https://developer.mozilla.org/en/Navigator.cookieEnabled
   */
  bool cookieEnabled;

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.language
   */
  String language;

  /**
   * @type {MimeTypeArray}
   * @see https://developer.mozilla.org/en/Navigator.mimeTypes
   */
  MimeTypeArray mimeTypes;

  /**
   * @type {boolean}
   * @see https://developer.mozilla.org/en/Navigator.onLine
   */
  bool onLine;

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.oscpu
   */
  String oscpu;

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.platform
   */
  String platform;

  /**
   * @type {PluginArray}
   * @see https://developer.mozilla.org/en/Navigator.plugins
   */
  PluginArray plugins;

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.product
   */
  String product;

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.productSub
   */
  String productSub;

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.securityPolicy
   */
  String securityPolicy;

  /**
   * @param {string} url
   * @param {ArrayBufferView|Blob|string|FormData=} opt_data
   * @return {boolean}
   * @see https://developer.mozilla.org/en-US/docs/Web/API/navigator.sendBeacon
   */
  bool sendBeacon(String url,
      [opt_data /*es6.ArrayBufferView|null|fileapi.Blob|String|w3c_xml.FormData|undefined*/]);

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.userAgent
   */
  String userAgent;

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.vendor
   */
  String vendor;

  /**
   * @type {string}
   * @see https://developer.mozilla.org/en/Navigator.vendorSub
   */
  String vendorSub;

  /**
   * @type {function(): boolean}
   * @see https://developer.mozilla.org/en/Navigator.javaEnabled
   * @nosideeffects
   */
  bool javaEnabled();

  /**
   * @type {string}
   * @see http://msdn.microsoft.com/en-us/library/ms533542(v=vs.85).aspx
   */
  String browserLanguage;

  /**
   * @type {number}
   * @see https://msdn.microsoft.com/en-us/library/ie/hh772144(v=vs.85).aspx
   */
  num msMaxTouchPoints;

  /**
   * @type {boolean}
   * @see http://blogs.msdn.com/b/ie/archive/2011/09/20/touch-input-for-ie10-and-metro-style-apps.aspx
   */
  bool msPointerEnabled;

  /** @type {Geolocation} */
  w3c_geolocation.Geolocation geolocation;

  /**
   * @param {MediaStreamConstraints} constraints A MediaStreamConstraints object.
   * @param {function(!MediaStream)} successCallback
   *     A NavigatorUserMediaSuccessCallback function.
   * @param {function(!NavigatorUserMediaError)=} errorCallback A
   *     NavigatorUserMediaErrorCallback function.
   * @see http://dev.w3.org/2011/webrtc/editor/getusermedia.html
   * @see http://www.w3.org/TR/mediacapture-streams/
   */
  webkitGetUserMedia(
      Object constraints, successCallback(w3c_rtc.MediaStream arg1),
      [errorCallback(w3c_rtc.NavigatorUserMediaError arg1)]);

  /** @type {!ServiceWorkerContainer} */
  w3c_serviceworker.ServiceWorkerContainer serviceWorker;
}
/**
 * Decodes a string of data which has been encoded using base-64 encoding.
 *
 * @param {string} encodedData
 * @return {string}
 * @see https://developer.mozilla.org/en/DOM/window.atob
 * @nosideeffects
 */
external String atob(String encodedData);
/**
 * @param {string} stringToEncode
 * @return {string}
 * @see https://developer.mozilla.org/en/DOM/window.btoa
 * @nosideeffects
 */
external String btoa(String stringToEncode);

/** @constructor */
@JsName("Selection")
abstract class Selection {
// @Ignore
  external Selection.fakeConstructor$();

  /**
   * @type {Node}
   * @see https://developer.mozilla.org/en/DOM/Selection/anchorNode
   */
  w3c_dom1.Node anchorNode;

  /**
   * @type {number}
   * @see https://developer.mozilla.org/en/DOM/Selection/anchorOffset
   */
  num anchorOffset;

  /**
   * @type {Node}
   * @see https://developer.mozilla.org/en/DOM/Selection/focusNode
   */
  w3c_dom1.Node focusNode;

  /**
   * @type {number}
   * @see https://developer.mozilla.org/en/DOM/Selection/focusOffset
   */
  num focusOffset;

  /**
   * @type {boolean}
   * @see https://developer.mozilla.org/en/DOM/Selection/isCollapsed
   */
  bool isCollapsed;

  /**
   * @type {number}
   * @see https://developer.mozilla.org/en/DOM/Selection/rangeCount
   */
  num rangeCount;

  /**
   * @param {Range} range
   * @return {undefined}
   * @see https://developer.mozilla.org/en/DOM/Selection/addRange
   */
  void addRange(w3c_range.Range range);

  /**
   * @param {number} index
   * @return {Range}
   * @see https://developer.mozilla.org/en/DOM/Selection/getRangeAt
   * @nosideeffects
   */
  w3c_range.Range getRangeAt(num index);

  /**
   * @param {Node} node
   * @param {number} index
   * @return {undefined}
   * @see https://developer.mozilla.org/en/DOM/Selection/collapse
   */
  void collapse(w3c_dom1.Node node, num index);

  /**
   * @return {undefined}
   * @see https://developer.mozilla.org/en/DOM/Selection/collapseToEnd
   */
  void collapseToEnd();

  /**
   * @return {undefined}
   * @see https://developer.mozilla.org/en/DOM/Selection/collapseToStart
   */
  void collapseToStart();

  /**
   * @param {Node} node
   * @param {boolean} partlyContained
   * @return {boolean}
   * @see https://developer.mozilla.org/en/DOM/Selection/containsNode
   * @nosideeffects
   */
  bool containsNode(w3c_dom1.Node node, bool partlyContained);

  /**
   * @see https://developer.mozilla.org/en/DOM/Selection/deleteFromDocument
   */
  deleteFromDocument();

  /**
   * @param {Node} parentNode
   * @param {number} offset
   * @see https://developer.mozilla.org/en/DOM/Selection/extend
   */
  extend(w3c_dom1.Node parentNode, num offset);

  /**
   * @see https://developer.mozilla.org/en/DOM/Selection/removeAllRanges
   */
  removeAllRanges();

  /**
   * @param {Range} range
   * @see https://developer.mozilla.org/en/DOM/Selection/removeRange
   */
  removeRange(w3c_range.Range range);

  /**
   * @param {Node} parentNode
   * @see https://developer.mozilla.org/en/DOM/Selection/selectAllChildren
   */
  external selectAllChildren(w3c_dom1.Node parentNode);
  /**
   * @see https://developer.mozilla.org/en/DOM/Selection/selectionLanguageChange
   */
  dynamic selectionLanguageChange;

  /**
   * @return {undefined}
   * @see http://msdn.microsoft.com/en-us/library/ms536418(VS.85).aspx
   */
  void clear();

  /**
   * @return {TextRange|ControlRange}
   * @see http://msdn.microsoft.com/en-us/library/ms536394(VS.85).aspx
   */
/*ie_dom.TextRange|null|ie_dom.ControlRange*/ createRange();

  /**
   * @return {Array.<TextRange>}
   * @see http://msdn.microsoft.com/en-us/library/ms536396(VS.85).aspx
   */
  List<ie_dom.TextRange> createRangeCollection();

  /** @type {Node} */
  w3c_dom1.Node baseNode;

  /** @type {number} */
  num baseOffset;

  /** @type {Node} */
  w3c_dom1.Node extentNode;

  /** @type {number} */
  num extentOffset;

  /** @type {string} */
  String type;

  /**
   * @return {undefined}
   */
  void empty();

  /**
   * @param {Node} baseNode
   * @param {number} baseOffset
   * @param {Node} extentNode
   * @param {number} extentOffset
   * @return {undefined}
   */
  void setBaseAndExtent(w3c_dom1.Node baseNode, num baseOffset,
      w3c_dom1.Node extentNode, num extentOffset);

  /**
   * @param {string} alter
   * @param {string} direction
   * @param {string} granularity
   * @return {undefined}
   */
  void modify(String alter, String direction, String granularity);
}

/**
 * @constructor
 * @see https://developer.mozilla.org/en/DOM/PluginArray
 */
@JsName("PluginArray")
abstract class PluginArray {
// @Ignore
  external PluginArray.fakeConstructor$();

  /** @type {number} */
  num length;

  /**
   * @param {number} index
   * @return {Plugin}
   */
  Plugin item(num index);

  /**
   * @param {string} name
   * @return {Plugin}
   */
  Plugin namedItem(String name);

  /** @param {boolean=} reloadDocuments */
  refresh([bool reloadDocuments]);
}

/** @constructor */
@JsName("MimeTypeArray")
abstract class MimeTypeArray {
// @Ignore
  external MimeTypeArray.fakeConstructor$();

  /**
   * @param {number} index
   * @return {MimeType}
   */
  MimeType item(num index);

  /**
   * @type {number}
   * @see https://developer.mozilla.org/en/DOM/window.navigator.mimeTypes
   */
  num length;

  /**
   * @param {string} name
   * @return {MimeType}
   */
  MimeType namedItem(String name);
}

/** @constructor */
@JsName("MimeType")
abstract class MimeType {
// @Ignore
  external MimeType.fakeConstructor$();

  /** @type {string} */
  String description;

  /** @type {Plugin} */
  Plugin enabledPlugin;

  /** @type {string} */
  String suffixes;

  /** @type {string} */
  String type;
}

/** @constructor */
@JsName("Plugin")
abstract class Plugin {
// @Ignore
  external Plugin.fakeConstructor$();

  /** @type {string} */
  String description;

  /** @type {string} */
  String filename;

  /** @type {number} */
  num length;

  /** @type {string} */
  String name;
}

/** @constructor */
@JsName("BoxObject")
abstract class BoxObject {
// @Ignore
  external BoxObject.fakeConstructor$();

  /** @type {Element} */
  w3c_dom1.Element element;

  /** @type {number} */
  num screenX;

  /** @type {number} */
  num screenY;

  /** @type {number} */
  num x;

  /** @type {number} */
  num y;

  /** @type {number} */
  num width;
}
/**
 * @param {Element} element
 * @param {?string=} pseudoElt
 * @return {CSSStyleDeclaration}
 * @nosideeffects
 */
external w3c_css.CSSStyleDeclaration getComputedStyle(w3c_dom1.Element element,
    [String pseudoElt]);
