/*
 * Copyright 2008 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for all the extensions over some of the
 *  W3C's XML specifications by Gecko. This file depends on
 *  w3c_xml.js. The whole file has been fully type annotated.
 *
 * FROM_EXTERN
 */
@JsName()
library gecko_xml;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "w3c_dom1.dart" as w3c_dom1;

/**
 * XMLSerializer can be used to convert DOM subtree or DOM document into text.
 * XMLSerializer is available to unprivileged scripts.
 *
 * XMLSerializer is mainly useful for applications and extensions based on
 * Mozilla platform. While it's available to web pages, it's not part of any
 * standard and level of support in other browsers is unknown.
 *
 * @constructor
 */
@JsName("XMLSerializer")
abstract class XMLSerializer {
// @Ignore
  external XMLSerializer.fakeConstructor$();

  /**
   * Returns the serialized subtree in the form of a string
   * @param {Node} subtree
   * @return {string}
   */
  String serializeToString(w3c_dom1.Node subtree);

  /**
   * The subtree rooted by the specified element is serialized to a byte stream
   * using the character set specified.
   *
   * @param {Node} subtree
   * @return {Object}
   */
  Object serializeToStream(w3c_dom1.Node subtree);
}

/**
 * DOMParser is mainly useful for applications and extensions based on Mozilla
 * platform. While it's available to web pages, it's not part of any standard and
 * level of support in other browsers is unknown.
 *
 * @constructor
 */
@JsName("DOMParser")
abstract class DOMParser {
// @Ignore
  external DOMParser.fakeConstructor$();

  /**
   * The string passed in is parsed into a DOM document.
   *
   * Example:
   *  var parser = new DOMParser();
   *  var doc = parser.parseFromString(aStr, "text/xml");
   *
   * @param {string} src The UTF16 string to be parsed.
   * @param {string} type The content type of the string.
   * @return {Document}
   */
  w3c_dom1.Document parseFromString(String src, String type);
}
