/*
 * Copyright 2008 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for all the extensions over the
 *  W3C's DOM specification by IE in JScript. This file depends on
 *  w3c_dom2.js. The whole file has NOT been fully type annotated.
 *
 * When a non-standard extension appears in both Gecko and IE, we put
 * it in gecko_dom.js
 *
 * FROM_EXTERN
 * @author stevey@google.com (Steve Yegge)
 */
@JsName()
library ie_dom;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "w3c_dom1.dart" as w3c_dom1;

import "w3c_dom3.dart" as w3c_dom3;

/**
 * @constructor
 * @extends {Document}
 * @see http://msdn.microsoft.com/en-us/library/ms757878(VS.85).aspx
 */
@JsName("XMLDOMDocument")
abstract class XMLDOMDocument extends w3c_dom1.Document {
// @Ignore
  external XMLDOMDocument.fakeConstructor$() : super.fakeConstructor$();

  /**
   * @type {boolean}
   * @see http://msdn.microsoft.com/en-us/library/ms761398(VS.85).aspx
   */
  bool async;

  /**
   * @type {!Function}
   * @see http://msdn.microsoft.com/en-us/library/ms762647(VS.85).aspx
   */
  Function ondataavailable;

  /**
   * @type {!Function}
   * @see http://msdn.microsoft.com/en-us/library/ms764640(VS.85).aspx
   */
  Function onreadystatechange;

  /**
   * @type {!Function}
   * @see http://msdn.microsoft.com/en-us/library/ms753795(VS.85).aspx
   */
  Function ontransformnode;

  /**
   * @type {Object}
   * @see http://msdn.microsoft.com/en-us/library/ms756041(VS.85).aspx
   */
  Object parseError;

  /**
   * @type {boolean}
   * @see http://msdn.microsoft.com/en-us/library/ms761353(VS.85).aspx
   */
  bool preserveWhiteSpace;

  /**
   * @type {number}
   * @see http://msdn.microsoft.com/en-us/library/ms753702(VS.85).aspx
   */
  num readyState;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms762283(VS.85).aspx
   * @type {boolean}
   */
  bool resolveExternals;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms760290(v=vs.85).aspx
   * @param {string} name
   * @param {*} value
   */
  setProperty(String name, value);

  /**
   * @type {string}
   * @see http://msdn.microsoft.com/en-us/library/ms767669(VS.85).aspx
   */
  String url;

  /**
   * @type {boolean}
   * @see http://msdn.microsoft.com/en-us/library/ms762791(VS.85).aspx
   */
  bool validateOnParse;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms763830(VS.85).aspx
   */
  abort();

  /**
   * @param {*} type
   * @param {string} name
   * @param {string} namespaceURI
   * @return {Node}
   * @see http://msdn.microsoft.com/en-us/library/ms757901(VS.85).aspx
   * @nosideeffects
   */
  w3c_dom1.Node createNode(type, String name, String namespaceURI);

  /**
   * @param {string} xmlSource
   * @return {boolean}
   * @see http://msdn.microsoft.com/en-us/library/ms762722(VS.85).aspx
   * @override
   */
  bool load(String xmlSource);

  /**
   * @param {string} xmlString
   * @return {boolean}
   * @see http://msdn.microsoft.com/en-us/library/ms754585(VS.85).aspx
   * @override
   */
  bool loadXML(String xmlString);

  /**
   * @param {string} id
   * @return {Node}
   * @see http://msdn.microsoft.com/en-us/library/ms766397(VS.85).aspx
   */
  w3c_dom1.Node nodeFromID(String id);
}

/**
 * @constructor
 */
@JsName("ClipboardData")
abstract class ClipboardData {
// @Ignore
  external ClipboardData.fakeConstructor$();

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms535220(VS.85).aspx
   * @param {string=} opt_type Type of clipboard data to clear. 'Text' or
   *     'URL' or 'File' or 'HTML' or 'Image'.
   */
  clearData([String opt_type]);

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms535220(VS.85).aspx
   * @param {string} type Type of clipboard data to set ('Text' or 'URL').
   * @param {string} data Data to set
   * @return {boolean} Whether the data were set correctly.
   */
  bool setData(String type, String data);

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms535220(VS.85).aspx
   * @param {string} type Type of clipboard data to get ('Text' or 'URL').
   * @return {string} The current data
   */
  String getData(String type);
}
/**
 * @type {!Window}
 * @see https://developer.mozilla.org/en/DOM/window
 */
@JsName("window")
external w3c_dom1.Window get window;
@JsName("window")
external set window(w3c_dom1.Window value);

/**
 * @constructor
 */
@JsName("History")
abstract class History {
// @Ignore
  external History.fakeConstructor$();

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms535864(VS.85).aspx
   * @param {number|string} delta The number of entries to go back, or
   *     the URL to which to go back. (URL form is supported only in IE)
   */
  go(delta /*num|String*/);

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms535864(VS.85).aspx
   * @param {number=} opt_distance The number of entries to go back
   *     (Mozilla doesn't support distance -- use #go instead)
   */
  back([num opt_distance]);

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms535864(VS.85).aspx
   * @type {number}
   */
  num length;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms535864(VS.85).aspx
   */
  forward();

  /**
   * Pushes a new state into the session history.
   * @see http://www.w3.org/TR/html5/history.html#the-history-interface
   * @param {*} data New state.
   * @param {string} title The title for a new session history entry.
   * @param {string=} opt_url The URL for a new session history entry.
   */
  pushState(data, String title, [String opt_url]);

  /**
   * Replaces the current state in the session history.
   * @see http://www.w3.org/TR/html5/history.html#the-history-interface
   * @param {*} data New state.
   * @param {string} title The title for a session history entry.
   * @param {string=} opt_url The URL for a new session history entry.
   */
  replaceState(data, String title, [String opt_url]);

  /**
   * Pending state object.
   * @see https://developer.mozilla.org/en-US/docs/Web/Guide/API/DOM/Manipulating_the_browser_history#Reading_the_current_state
   * @type {*}
   */
  dynamic state;
}

/**
 * @constructor
 */
@JsName("ControlRange")
abstract class ControlRange {
// @Ignore
  external ControlRange.fakeConstructor$();

  dynamic add;

  dynamic addElement;

  dynamic execCommand;

  dynamic item;

  dynamic queryCommandEnabled;

  dynamic queryCommandIndeterm;

  dynamic queryCommandState;

  dynamic queryCommandSupported;

  dynamic queryCommandValue;

  dynamic remove;

  dynamic scrollIntoView;

  dynamic select;
}

/**
 * @constructor
 * @see http://msdn.microsoft.com/en-us/library/ms535872.aspx
 */
@JsName("TextRange")
abstract class TextRange {
// @Ignore
  external TextRange.fakeConstructor$();

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms533538(VS.85).aspx
   */
  dynamic boundingHeight;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms533539(VS.85).aspx
   */
  dynamic boundingLeft;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms533540(VS.85).aspx
   */
  dynamic boundingTop;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms533541(VS.85).aspx
   */
  dynamic boundingWidth;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms533874(VS.85).aspx
   */
  dynamic htmlText;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms534200(VS.85).aspx
   */
  dynamic offsetLeft;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms534303(VS.85).aspx
   */
  dynamic offsetTop;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms534676(VS.85).aspx
   */
  dynamic text;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536371(VS.85).aspx
   */
  dynamic collapse;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536373(VS.85).aspx
   */
  dynamic compareEndPoints;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536416(VS.85).aspx
   */
  dynamic duplicate;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536419(VS.85).aspx
   */
  dynamic execCommand;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536421(VS.85).aspx
   */
  dynamic expand;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536422(VS.85).aspx
   */
  dynamic findText;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536432(VS.85).aspx
   */
  dynamic getBookmark;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536433(VS.85).aspx
   */
  dynamic getBoundingClientRect;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536435(VS.85).aspx
   */
  dynamic getClientRects;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536450(VS.85).aspx
   */
  dynamic inRange;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536458(VS.85).aspx
   */
  dynamic isEqual;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536616(VS.85).aspx
   */
  dynamic move;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536620(VS.85).aspx
   */
  dynamic moveEnd;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536623(VS.85).aspx
   */
  dynamic moveStart;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536628(VS.85).aspx
   */
  dynamic moveToBookmark;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536630(VS.85).aspx
   */
  dynamic moveToElementText;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536632(VS.85).aspx
   */
  dynamic moveToPoint;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536654(VS.85).aspx
   */
  dynamic parentElement;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536656(VS.85).aspx
   */
  dynamic pasteHTML;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536676(VS.85).aspx
   */
  dynamic queryCommandEnabled;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536678(VS.85).aspx
   */
  dynamic queryCommandIndeterm;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536679(VS.85).aspx
   */
  dynamic queryCommandState;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536681(VS.85).aspx
   */
  dynamic queryCommandSupported;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536683(VS.85).aspx
   */
  dynamic queryCommandValue;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536730(VS.85).aspx
   */
  dynamic scrollIntoView;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536735(VS.85).aspx
   */
  dynamic select;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536745(VS.85).aspx
   */
  dynamic setEndPoint;
}

/**
 * @constructor
 * @see http://msdn.microsoft.com/en-us/library/ms537447(VS.85).aspx
 */
@JsName("controlRange")
abstract class controlRange {
// @Ignore
  external controlRange.fakeConstructor$();
}

/**
 * @constructor
 * @see http://msdn.microsoft.com/en-us/library/aa752462(v=vs.85).aspx
 */
@JsName("HTMLFiltersCollection")
abstract class HTMLFiltersCollection {
// @Ignore
  external HTMLFiltersCollection.fakeConstructor$();

  /**
   * @see http://msdn.microsoft.com/en-us/library/aa752463(v=vs.85).aspx
   * @type {number}
   */
  num length;
}

/**
 * @constructor
 * @see http://msdn.microsoft.com/en-us/library/ms532853(v=vs.85).aspx
 */
@JsName("HTMLFilter")
abstract class HTMLFilter {
// @Ignore
  external HTMLFilter.fakeConstructor$();

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms532954(v=vs.85).aspx
   */
  apply();
}

/**
 * @constructor
 * @extends {HTMLFilter}
 * @see http://msdn.microsoft.com/en-us/library/ms532967(v=vs.85).aspx
 */
@JsName("AlphaFilter")
abstract class AlphaFilter extends HTMLFilter {
// @Ignore
  external AlphaFilter.fakeConstructor$() : super.fakeConstructor$();

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms532910(v=vs.85).aspx
   * @type {number}
   */
  num Opacity;
}

/**
 * @constructor
 * @extends {HTMLFilter}
 * @see http://msdn.microsoft.com/en-us/library/ms532969(v=vs.85).aspx
 */
@JsName("AlphaImageLoaderFilter")
abstract class AlphaImageLoaderFilter extends HTMLFilter {
// @Ignore
  external AlphaImageLoaderFilter.fakeConstructor$() : super.fakeConstructor$();

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms532920(v=vs.85).aspx
   * @type {string}
   */
  String sizingMethod;
}

/**
 * @constructor
 * @see http://msdn.microsoft.com/en-us/library/ms535866(VS.85).aspx
 */
@JsName("Location")
abstract class Location {
// @Ignore
  external Location.fakeConstructor$();

  /**
   * @see http://trac.webkit.org/changeset/113945
   * @type {DOMStringList}
   */
  w3c_dom3.DOMStringList ancestorOrigins;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms533775(VS.85).aspx
   * @type {string}
   */
  String hash;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms533784(VS.85).aspx
   * @type {string}
   */
  String host;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms533785(VS.85).aspx
   * @type {string}
   */
  String hostname;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms533867(VS.85).aspx
   * @type {string}
   */
  String href;

  /**
   * @see https://docs.google.com/document/view?id=1r_VTFKApVOaNIkocrg0z-t7lZgzisTuGTXkdzAk4gLU&hl=en
   * @type {string}
   */
  String origin;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms534332(VS.85).aspx
   * @type {string}
   */
  String pathname;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms534342(VS.85).aspx
   */
  dynamic port;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms534353(VS.85).aspx
   * @type {string}
   */
  String protocol;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms534620(VS.85).aspx
   * @type {string}
   */
  String search;

  /**
   * @see http://msdn.microsoft.com/en-us/library/ms536342(VS.85).aspx
   * @param {string} url
   */
  assign(String url);

  /**
   * @param {boolean=} opt_forceReload If true, reloads the page from
   *     the server. Defaults to false.
   * @see http://msdn.microsoft.com/en-us/library/ms536691(VS.85).aspx
   */
  reload([bool opt_forceReload]);

  /**
   * @param {string} url
   * @see http://msdn.microsoft.com/en-us/library/ms536712(VS.85).aspx
   */
  replace(String url);
}
/** @param {*=} opt_str */
external RuntimeObject([opt_str]);

/**
 * IE implements Cross Origin Resource Sharing (cross-domain XMLHttpRequests)
 * via the XDomainRequest object.
 *
 * @constructor
 * @see http://msdn.microsoft.com/en-us/library/cc288060(v=vs.85).aspx
 * @see http://www.w3.org/TR/cors/
 */
@JsName("XDomainRequest")
abstract class XDomainRequest {
// @Ignore
  external XDomainRequest.fakeConstructor$();

  /**
   * Aborts the request.
   * @see http://msdn.microsoft.com/en-us/library/cc288129(v=vs.85).aspx
   */
  abort();

  /**
   * Sets the method and URL for the request.
   * @param {string} bstrMethod Either "GET" or "POST"
   * @param {string} bstrUrl The target URL
   * @see http://msdn.microsoft.com/en-us/library/cc288168(v=vs.85).aspx
   */
  open(String bstrMethod, String bstrUrl);

  /**
   * Sends the request.
   * @param {string=} varBody The POST body to send to the server. If omitted,
   *     the behavior is identical to sending an empty string.
   * @see http://msdn.microsoft.com/en-us/library/cc288207(v=vs.85).aspx
   */
  send([String varBody]);

  /**
   * Called if the request could not be completed. Note that error information is
   * not available.
   * @see http://msdn.microsoft.com/en-us/library/ms536930%28v=VS.85%29.aspx
   * @type {?function()}
   */
  Func0<dynamic> onerror;

  /**
   * Called when the response has finished.
   * @see http://msdn.microsoft.com/en-us/library/ms536942%28v=VS.85%29.aspx
   * @type {?function()}
   */
  Func0<dynamic> onload;

  /**
   * Called every time part of the response has been received.
   * @see http://msdn.microsoft.com/en-us/library/cc197058%28v=VS.85%29.aspx
   * @type {?function()}
   */
  Func0<dynamic> onprogress;

  /**
   * Called if the timeout period has elapsed.
   * @see http://msdn.microsoft.com/en-us/library/cc197061%28v=VS.85%29.aspx
   * @type {?function()}
   */
  Func0<dynamic> ontimeout;

  /**
   * The current response body.
   * @see http://msdn.microsoft.com/en-us/library/cc287956%28v=VS.85%29.aspx
   * @type {string}
   */
  String responseText;

  /**
   * The timeout (in milliseconds) for the request.
   * @type {number}
   */
  num timeout;

  /**
   * The Content-Type of the response, or an empty string.
   * @type {string}
   */
  String contentType;
}
