/*
 * Copyright 2008 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for all the extensions over the
 *  W3C's event specification by IE in JScript. This file depends on
 *  w3c_event.js.
 *
 * @see http://msdn.microsoft.com/en-us/library/ms535863.aspx
 * FROM_EXTERN
 */
@JsName()
library ie_event;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "w3c_dom1.dart" as w3c_dom1;

import "w3c_event.dart" as w3c_event;

/**
 * @constructor
 * @see http://msdn.microsoft.com/en-us/library/windows/apps/hh441257.aspx
 */
@JsName("MSPointerPoint")
abstract class MSPointerPoint {
// @Ignore
  external MSPointerPoint.fakeConstructor$();

  /** @type {number} */
  num pointerId;

  /** @type {number} */
  num pointerType;
}

/**
 * @constructor
 * @extends {Event}
 * @see http://msdn.microsoft.com/en-us/library/windows/apps/hh441233.aspx
 */
@JsName("MSPointerEvent")
abstract class MSPointerEvent extends w3c_event.Event {
// @Ignore
  external MSPointerEvent.fakeConstructor$() : super.fakeConstructor$();

  /** @type {number} */
  external static num get MSPOINTER_TYPE_TOUCH;

  external static set MSPOINTER_TYPE_TOUCH(num value);

  /** @type {number} */
  external static num get MSPOINTER_TYPE_PEN;

  external static set MSPOINTER_TYPE_PEN(num value);

  /** @type {number} */
  external static num get MSPOINTER_TYPE_MOUSE;

  external static set MSPOINTER_TYPE_MOUSE(num value);

  /** @type {number} */
  num height;

  /** @type {number} */
  num hwTimestamp;

  /** @type {boolean} */
  bool isPrimary;

  /** @type {number} */
  num pointerId;

  /** @type {number} */
  num pointerType;

  /** @type {number} */
  num pressure;

  /** @type {number} */
  num rotation;

  /** @type {number} */
  num tiltX;

  /** @type {number} */
  num tiltY;

  /** @type {number} */
  num timeStamp;

  /** @type {number} */
  num width;

  /**
   * @param {number} pointerId
   * @return {undefined}
   */
  external void msReleasePointerCapture(num pointerId);
  /**
   * @param {number} pointerId
   * @return {undefined}
   */
  external void msSetPointerCapture(num pointerId);
  /**
   * @param {string} typeArg
   * @param {boolean} canBubbleArg
   * @param {boolean} cancelableArg
   * @param {Window} viewArg
   * @param {number} detailArg
   * @param {number} screenXArg
   * @param {number} screenYArg
   * @param {number} clientXArg
   * @param {number} clientYArg
   * @param {boolean} ctrlKeyArg
   * @param {boolean} altKeyArg
   * @param {boolean} shiftKeyArg
   * @param {boolean} metaKeyArg
   * @param {number} buttonArg
   * @param {Element} relatedTargetArg
   * @param {number} offsetXArg
   * @param {number} offsetYArg
   * @param {number} widthArg
   * @param {number} heightArg
   * @param {number} pressure
   * @param {number} rotation
   * @param {number} tiltX
   * @param {number} tiltY
   * @param {number} pointerIdArg
   * @param {number} pointerType
   * @param {number} hwTimestampArg
   * @param {boolean} isPrimary
   * @return {undefined}
   * @see http://msdn.microsoft.com/en-us/library/windows/apps/hh441246.aspx
   */
  external void initPointerEvent(String typeArg, bool canBubbleArg,
      bool cancelableArg, w3c_dom1.Window viewArg, num detailArg,
      num screenXArg, num screenYArg, num clientXArg, num clientYArg,
      bool ctrlKeyArg, bool altKeyArg, bool shiftKeyArg, bool metaKeyArg,
      num buttonArg, w3c_dom1.Element relatedTargetArg, num offsetXArg,
      num offsetYArg, num widthArg, num heightArg, num pressure, num rotation,
      num tiltX, num tiltY, num pointerIdArg, num pointerType,
      num hwTimestampArg, bool isPrimary);
}

/**
 * @constructor
 * @see http://msdn.microsoft.com/en-us/library/ie/hh968249(v=vs.85).aspx
 */
@JsName("MSGesture")
abstract class MSGesture {
// @Ignore
  external MSGesture.fakeConstructor$();

  /**
   * @type {Element}
   */
  w3c_dom1.Element target;

  /**
   * @param {number} pointerId
   */
  addPointer(num pointerId);

  stop();
}

/**
 * @constructor
 * @extends {Event}
 * @see http://msdn.microsoft.com/en-us/library/ie/hh772076(v=vs.85).aspx
 */
@JsName("MSGestureEvent")
abstract class MSGestureEvent extends w3c_event.Event {
// @Ignore
  external MSGestureEvent.fakeConstructor$() : super.fakeConstructor$();

  /** @type {number} */
  num expansion;

  /** @type {!MSGesture} */
  MSGesture gestureObject;

  /** @type {number} */
  num hwTimestamp;

  /** @type {number} */
  num rotation;

  /** @type {number} */
  num scale;

  /** @type {number} */
  num translationX;

  /** @type {number} */
  num translationY;

  /** @type {number} */
  num velocityAngular;

  /** @type {number} */
  num velocityExpansion;

  /** @type {number} */
  num velocityX;

  /** @type {number} */
  num velocityY;

  /**
   * @param {string} typeArg
   * @param {boolean} canBubbleArg
   * @param {boolean} cancelableArg
   * @param {Window} viewArg
   * @param {number} detailArg
   * @param {number} screenXArg
   * @param {number} screenYArg
   * @param {number} clientXArg
   * @param {number} clientYArg
   * @param {number} offsetXArg
   * @param {number} offsetYArg
   * @param {number} translationXArg
   * @param {number} translationYArg
   * @param {number} scaleArg
   * @param {number} expansionArg
   * @param {number} rotationArg
   * @param {number} velocityXArg
   * @param {number} velocityYArg
   * @param {number} velocityExpansionArg
   * @param {number} velocityAngularArg
   * @param {number} hwTimestampArg
   * @param {EventTarget} relatedTargetArg
   * @return {undefined}
   * @see http://msdn.microsoft.com/en-us/library/windows/apps/hh441187.aspx
   */
  external void initGestureEvent(String typeArg, bool canBubbleArg,
      bool cancelableArg, w3c_dom1.Window viewArg, num detailArg,
      num screenXArg, num screenYArg, num clientXArg, num clientYArg,
      num offsetXArg, num offsetYArg, num translationXArg, num translationYArg,
      num scaleArg, num expansionArg, num rotationArg, num velocityXArg,
      num velocityYArg, num velocityExpansionArg, num velocityAngularArg,
      num hwTimestampArg, w3c_event.EventTarget relatedTargetArg);
}
