/*
 * Copyright 2013 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for the JS Internationalization API as defined in
 * http://www.ecma-international.org/ecma-402/1.0/
 *
 * FROM_EXTERN
 */
@JsName()
library intl;

import 'package:js/js.dart';
import 'package:func/func.dart';

/** @const */

@JsName("Intl.v8BreakIterator")
abstract class v8BreakIterator {
// @Ignore
  external v8BreakIterator.fakeConstructor$();

  /**
   * NOTE: this API is not from ecma402 and is subject to change.
   * @param {string|Array.<string>=} opt_locales
   * @param {{type: (string|undefined)}=}
   *         opt_options
   * @constructor
   */
  external factory v8BreakIterator(
      [opt_locales /*String|List<String>|null|undefined*/,
      OptionsRecord opt_options]);

  /**
   * @param {string} text
   */
  adoptText(String text);

  /**
   * @return {string}
   */
  String breakType();

  /**
   * @return {number}
   */
  num current();

  /**
   * @return {number}
   */
  num first();

  /**
   * @return {number}
   */
  num next();
}

@JsName("Intl.Collator")
abstract class Collator {
// @Ignore
  external Collator.fakeConstructor$();

  /**
   * @param {Array.<string>} locales
   * @param {{localeMatcher: (string|undefined)}=} opt_options
   */
  external static supportedLocalesOf(List<String> locales,
      [OptionsRecord3 opt_options]);

  /**
   * @constructor
   * @param {string|Array.<string>=} opt_locales
   * @param {{usage: (string|undefined), localeMatcher: (string|undefined),
   *     sensitivity: (string|undefined), ignorePunctuation: (boolean|undefined),
   *     numeric: (boolean|undefined), caseFirst: (string|undefined)}=}
   *         opt_options
   */
  external factory Collator([opt_locales /*String|List<String>|null|undefined*/,
      OptionsRecord2 opt_options]);

  /**
   * @param {string} arg1
   * @param {string} arg2
   * @return {number}
   */
  num compare(String arg1, String arg2);

  /**
   * @return {{locale: string, usage: string, sensitivity: string,
   *     ignorePunctuation: boolean, collation: string, numeric: boolean,
   *     caseFirst: string}}
   */
  ResolvedOptionsRecord resolvedOptions();
}

@JsName("Intl.NumberFormat")
abstract class NumberFormat {
// @Ignore
  external NumberFormat.fakeConstructor$();

  /**
   * @param {Array.<string>} locales
   * @param {{localeMatcher: (string|undefined)}=} opt_options
   */
  external static supportedLocalesOf(List<String> locales,
      [OptionsRecord3 opt_options]);

  /**
   * @constructor
   * @param {string|Array.<string>=} opt_locales
   * @param {{localeMatcher: (string|undefined), useGrouping: (boolean|undefined),
   *     numberingSystem: (string|undefined), style: (string|undefined),
   *     currency: (string|undefined), currencyDisplay: (string|undefined),
   *     minimumIntegerDigits: (number|undefined),
   *     minimumFractionDigits: (number|undefined),
   *     maximumFractionDigits: (number|undefined),
   *     minimumSignificantDigits: (number|undefined),
   *     maximumSignificantDigits: (number|undefined)}=}
   *         opt_options
   */
  external factory NumberFormat(
      [opt_locales /*String|List<String>|null|undefined*/,
      OptionsRecord4 opt_options]);

  /**
   * @param {number} num
   * @return {string}
   */
  String format(num num);

  /**
   * @return {{locale: string, numberingSystem: string, style: string,
   *     currency: (string|undefined), currencyDisplay: (string|undefined),
   *     minimumIntegerDigits: number, minimumFractionDigits: number,
   *     maximumFractionDigits: number, minimumSignificantDigits: number,
   *     maximumSignificantDigits: number, useGrouping: boolean}}
   */
  ResolvedOptionsRecord2 resolvedOptions();
}

@JsName("Intl.DateTimeFormat")
abstract class DateTimeFormat {
// @Ignore
  external DateTimeFormat.fakeConstructor$();

  /**
   * @param {Array.<string>} locales
   * @param {{localeMatcher: string}=} opt_options
   */
  external static supportedLocalesOf(List<String> locales,
      [OptionsRecord6 opt_options]);

  /**
   * @constructor
   * @param {string|Array.<string>=} opt_locales
   * @param {{localeMatcher: (string|undefined),
   *    formatMatcher: (string|undefined), calendar: (string|undefined),
   *    numberingSystem: (string|undefined), tz: (string|undefined),
   *    weekday: (string|undefined), era: (string|undefined),
   *    year: (string|undefined), month: (string|undefined),
   *    day: (string|undefined), hour: (string|undefined),
   *    minute: (string|undefined), second: (string|undefined),
   *    timeZoneName: (string|undefined), hour12: (boolean|undefined)}=}
   *        opt_options
   */
  external factory DateTimeFormat(
      [opt_locales /*String|List<String>|null|undefined*/,
      OptionsRecord5 opt_options]);

  /**
   * @param {number} date
   * @return {string}
   */
  String format(num date);

  /**
   * @return {{locale: string, calendar: string, numberingSystem: string,
   *    timeZone: (string|undefined), weekday: (string|undefined),
   *    era: (string|undefined), year: (string|undefined),
   *    month: (string|undefined), day: (string|undefined),
   *    hour: (string|undefined), minute: (string|undefined),
   *    second: (string|undefined), timeZoneName: (string|undefined),
   *    hour12: (boolean|undefined)}}
   */
  ResolvedOptionsRecord3 resolvedOptions();
}
/// This record class is not given a name in the Closure JavaScript code base.
/// The name we have chosen may not make sense.
@JsName()
abstract class OptionsRecord {
  String type;
}
/// This record class is not given a name in the Closure JavaScript code base.
/// The name we have chosen may not make sense.
@JsName()
abstract class OptionsRecord2 {
  String caseFirst;
  bool ignorePunctuation;
  String localeMatcher;
  bool numeric;
  String sensitivity;
  String usage;
}
/// This record class is not given a name in the Closure JavaScript code base.
/// The name we have chosen may not make sense.
@JsName()
abstract class ResolvedOptionsRecord {
  String caseFirst;
  String collation;
  bool ignorePunctuation;
  String locale;
  bool numeric;
  String sensitivity;
  String usage;
}
/// This record class is not given a name in the Closure JavaScript code base.
/// The name we have chosen may not make sense.
@JsName()
abstract class OptionsRecord3 {
  String localeMatcher;
}
/// This record class is not given a name in the Closure JavaScript code base.
/// The name we have chosen may not make sense.
@JsName()
abstract class OptionsRecord4 {
  String currency;
  String currencyDisplay;
  String localeMatcher;
  num maximumFractionDigits;
  num maximumSignificantDigits;
  num minimumFractionDigits;
  num minimumIntegerDigits;
  num minimumSignificantDigits;
  String numberingSystem;
  String style;
  bool useGrouping;
}
/// This record class is not given a name in the Closure JavaScript code base.
/// The name we have chosen may not make sense.
@JsName()
abstract class ResolvedOptionsRecord2 {
  String currency;
  String currencyDisplay;
  String locale;
  num maximumFractionDigits;
  num maximumSignificantDigits;
  num minimumFractionDigits;
  num minimumIntegerDigits;
  num minimumSignificantDigits;
  String numberingSystem;
  String style;
  bool useGrouping;
}
/// This record class is not given a name in the Closure JavaScript code base.
/// The name we have chosen may not make sense.
@JsName()
abstract class OptionsRecord5 {
  String calendar;
  String day;
  String era;
  String formatMatcher;
  String hour;
  bool hour12;
  String localeMatcher;
  String minute;
  String month;
  String numberingSystem;
  String second;
  String timeZoneName;
  String tz;
  String weekday;
  String year;
}
/// This record class is not given a name in the Closure JavaScript code base.
/// The name we have chosen may not make sense.
@JsName()
abstract class ResolvedOptionsRecord3 {
  String calendar;
  String day;
  String era;
  String hour;
  bool hour12;
  String locale;
  String minute;
  String month;
  String numberingSystem;
  String second;
  String timeZone;
  String timeZoneName;
  String weekday;
  String year;
}
/// This record class is not given a name in the Closure JavaScript code base.
/// The name we have chosen may not make sense.
@JsName()
abstract class OptionsRecord6 {
  String localeMatcher;
}
