/*
 * Copyright 2012 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for the Media Source Extensions. Note that the
 * properties available here are the union of several versions of the spec.
 * @see http://dvcs.w3.org/hg/html-media/raw-file/tip/media-source/media-source.html
 *
 * FROM_EXTERN
 */
@JsName()
library mediasource;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "es6.dart" as es6;

import "html5.dart" as html5;

import "w3c_event.dart" as w3c_event;

/**
 * @constructor
 * @implements {EventTarget}
 */
@JsName("MediaSource")
abstract class MediaSource implements w3c_event.EventTarget {
// @Ignore
  external MediaSource.fakeConstructor$();

  /**
   * @param {string} type
   * @return {boolean}
   */
  external static bool isTypeSupported(String type);

  /**
   * @param {boolean=} opt_useCapture
   * @override
   */
  addEventListener(String type, bool listener(w3c_event.Event arg1),
      [bool opt_useCapture]);

  /**
   * @param {boolean=} opt_useCapture
   * @override
   */
  removeEventListener(String type, bool listener(w3c_event.Event arg1),
      [bool opt_useCapture]);

  /** @override */
  bool dispatchEvent(w3c_event.Event evt);

  /** @type {Array.<SourceBuffer>} */
  List<SourceBuffer> sourceBuffers;

  /** @type {Array.<SourceBuffer>} */
  List<SourceBuffer> activeSourceBuffers;

  /** @type {number} */
  num duration;

  /**
   * @param {string} type
   * @return {SourceBuffer}
   */
  SourceBuffer addSourceBuffer(String type);

  /**
   * @param {SourceBuffer} sourceBuffer
   */
  removeSourceBuffer(SourceBuffer sourceBuffer);

  /** @type {string} */
  String readyState;

  /**
   * @param {string=} opt_error
   */
  endOfStream([String opt_error]);
}

/**
 * @constructor
 * @implements {EventTarget}
 */
@JsName("SourceBuffer")
abstract class SourceBuffer implements w3c_event.EventTarget {
// @Ignore
  external SourceBuffer.fakeConstructor$();

  /**
   * @param {boolean=} opt_useCapture
   * @override
   */
  addEventListener(String type, bool listener(w3c_event.Event arg1),
      [bool opt_useCapture]);

  /**
   * @param {boolean=} opt_useCapture
   * @override
   */
  removeEventListener(String type, bool listener(w3c_event.Event arg1),
      [bool opt_useCapture]);

  /** @override */
  bool dispatchEvent(w3c_event.Event evt);

  /** @type {string} */
  String appendMode;

  /** @type {boolean} */
  bool updating;

  /** @type {TimeRanges} */
  html5.TimeRanges buffered;

  /** @type {number} */
  num timestampOffset;

  /** @type {number} */
  num appendWindowStart;

  /** @type {number} */
  num appendWindowEnd;

  /**
   * @param {Uint8Array} data
   */
  append(es6.Uint8Array data);

  /**
   * @param {ArrayBuffer|ArrayBufferView} data
   */
  appendBuffer(data /*es6.ArrayBuffer|null|es6.ArrayBufferView*/);

  /**
   * Abort the current segment append sequence.
   */
  abort();

  /**
   * @param {number} start
   * @param {number} end
   */
  remove(num start, num end);
}
