/*
 * Copyright 2011 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for timing control for script base animations. The
 *  whole file has been fully type annotated.
 *
 * @see http://www.w3.org/TR/animation-timing/
 * @see http://webstuff.nfshost.com/anim-timing/Overview.html
 * FROM_EXTERN
 */
@JsName()
library w3c_anim_timing;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "w3c_dom1.dart" as w3c_dom1;

/**
 * @param {function(number)} callback
 * @param {Element=} opt_element In early versions of this API, the callback
 *     was invoked only if the element was visible.
 * @return {number}
 */
external num requestAnimationFrame(callback(num arg1),
    [w3c_dom1.Element opt_element]);
/**
 * @param {number} handle
 */
external cancelRequestAnimationFrame(num handle);
/**
 * @param {function(number)} callback
 * @param {Element=} opt_element
 * @return {number}
 */
external num webkitRequestAnimationFrame(callback(num arg1),
    [w3c_dom1.Element opt_element]);
/**
 * @param {number} handle
 */
external webkitCancelRequestAnimationFrame(num handle);
/**
 * @param {number} handle
 */
external webkitCancelAnimationFrame(num handle);
/**
 * @param {?function(number)} callback It's legitimate to pass a null
 *     callback and listen on the MozBeforePaint event instead.
 * @param {Element=} opt_element
 * @return {number}
 */
external num mozRequestAnimationFrame(callback(num arg1),
    [w3c_dom1.Element opt_element]);
/**
 * @param {number} handle
 */
external mozCancelRequestAnimationFrame(num handle);
/**
 * @param {number} handle
 */
external mozCancelAnimationFrame(num handle);
/**
 * @param {function(number)} callback
 * @param {Element=} opt_element
 * @return {number}
 */
external num msRequestAnimationFrame(callback(num arg1),
    [w3c_dom1.Element opt_element]);
/**
 * @param {number} handle
 */
external msCancelRequestAnimationFrame(num handle);
/**
 * @param {number} handle
 */
external msCancelAnimationFrame(num handle);
/**
 * @param {function(number)} callback
 * @param {Element=} opt_element
 * @return {number}
 */
external num oRequestAnimationFrame(callback(num arg1),
    [w3c_dom1.Element opt_element]);
/**
 * @param {number} handle
 */
external oCancelRequestAnimationFrame(num handle);
/**
 * @param {number} handle
 */
external oCancelAnimationFrame(num handle);
