/*
 * Copyright 2015 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for W3C's Battery Status API.
 *  The whole file has been fully type annotated. Created from
 *  http://www.w3.org/TR/2014/CR-battery-status-20141209/
 *
 * FROM_EXTERN
 */
@JsName()
library w3c_batterystatus;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "w3c_event.dart" as w3c_event;

/**
 * @interface
 * @extends {EventTarget}
 */
@JsName("BatteryManager")
abstract class BatteryManager {
// @Ignore
  external BatteryManager.fakeConstructor$();

  /**
   * @type {boolean}
   */
  bool charging;

  /**
   * @type {number}
   */
  num chargingTime;

  /**
   * @type {number}
   */
  num dischargingTime;

  /**
   * @type {number}
   */
  num level;

  /**
   * @type {?function(!Event)}
   */
  Func1<w3c_event.Event, dynamic> onchargingchange;

  /**
   * @type {?function(!Event)}
   */
  Func1<w3c_event.Event, dynamic> onchargingtimechange;

  /**
   * @type {?function(!Event)}
   */
  Func1<w3c_event.Event, dynamic> ondischargingtimechange;

  /**
   * @type {?function(!Event)}
   */
  Func1<w3c_event.Event, dynamic> onlevelchange;
}
