/*
 * Copyright 2013 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for W3C's device orientation and device motion
 *  events specification.
 *  This file depends on w3c_event.js.
 *  The whole file has been partially type annotated.
 *  Created from http://dev.w3.org/geo/api/spec-source-orientation.
 *
 * FROM_EXTERN
 */
@JsName()
library w3c_device_sensor_event;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "w3c_event.dart" as w3c_event;

/**
 * @constructor
 * @extends {Event}
 */
@JsName("DeviceOrientationEvent")
abstract class DeviceOrientationEvent extends w3c_event.Event {
// @Ignore
  external DeviceOrientationEvent.fakeConstructor$() : super.fakeConstructor$();

  /** @type {?number} */
  num alpha;

  /** @type {?number} */
  num beta;

  /** @type {?number} */
  num gamma;

  /** @type {boolean} */
  bool absolute;

  /**
   * @type {?number}
   * @see https://developer.apple.com/library/safari/documentation/SafariDOMAdditions/Reference/DeviceOrientationEventClassRef/DeviceOrientationEvent/DeviceOrientationEvent.html#//apple_ref/javascript/instp/DeviceOrientationEvent/webkitCompassAccuracy
   */
  num webkitCompassAccuracy;

  /**
   * @type {?number}
   * @see https://developer.apple.com/library/safari/documentation/SafariDOMAdditions/Reference/DeviceOrientationEventClassRef/DeviceOrientationEvent/DeviceOrientationEvent.html#//apple_ref/javascript/instp/DeviceOrientationEvent/webkitCompassHeading
   */
  num webkitCompassHeading;
}

/**
 * @constructor
 */
@JsName("DeviceAcceleration")
abstract class DeviceAcceleration {
// @Ignore
  external DeviceAcceleration.fakeConstructor$();

  /** @type {?number} */
  num x;

  /** @type {?number} */
  num y;

  /** @type {?number} */
  num z;
}

/**
 * @constructor
 */
@JsName("DeviceRotationRate")
abstract class DeviceRotationRate {
// @Ignore
  external DeviceRotationRate.fakeConstructor$();

  /** @type {?number} */
  num alpha;

  /** @type {?number} */
  num beta;

  /** @type {?number} */
  num gamma;
}

/**
 * @constructor
 * @extends {Event}
 */
@JsName("DeviceMotionEvent")
abstract class DeviceMotionEvent extends w3c_event.Event {
// @Ignore
  external DeviceMotionEvent.fakeConstructor$() : super.fakeConstructor$();

  /** @type {?DeviceAcceleration} */
  DeviceAcceleration acceleration;

  /** @type {?DeviceAcceleration} */
  DeviceAcceleration accelerationIncludingGravity;

  /** @type {?DeviceRotationRate} */
  DeviceRotationRate rotationRate;

  /** @type {?number} */
  num interval;
}
