/*
 * Copyright 2015 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for W3C's Encoding specification
 *     https://encoding.spec.whatwg.org
 * FROM_EXTERN
 */
@JsName()
library w3c_encoding;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "es6.dart" as es6;

/**
 * @constructor
 * @param {string=} encoding
 * @param {Object=} options
 */
@JsName("TextDecoder")
abstract class TextDecoder {
// @Ignore
  external TextDecoder.fakeConstructor$();

  /**
   * @constructor
   * @param {string=} encoding
   * @param {Object=} options
   */
  external factory TextDecoder([String encoding, Object options]);

  /** @type {string} **/
  String encoding;

  /** @type {boolean} **/
  bool fatal;

  /** @type {boolean} **/
  bool ignoreBOM;

  /**
   * @param {!Uint8Array} input
   * @param {Object=} options
   * @return {string}
   */
  String decode(es6.Uint8Array input, [Object options]);
}

/**
 * @constructor
 * @param {string=} encoding
 * @param {Object=} options
 */
@JsName("TextEncoder")
abstract class TextEncoder {
// @Ignore
  external TextEncoder.fakeConstructor$();

  /**
   * @constructor
   * @param {string=} encoding
   * @param {Object=} options
   */
  external factory TextEncoder([String encoding, Object options]);

  /** @type {string} **/
  String encoding;

  /**
   * @param {string} input
   * @return {!Uint8Array}
   */
  es6.Uint8Array encode(String input);
}
