/*
 * Copyright 2009 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for W3C's Geolocation specification
 *     http://www.w3.org/TR/geolocation-API/
 * FROM_EXTERN
 */
@JsName()
library w3c_geolocation;

import 'package:js/js.dart';
import 'package:func/func.dart';

/**
 * @constructor
 * @see http://www.w3.org/TR/geolocation-API/#geolocation
 */
@JsName("Geolocation")
abstract class Geolocation {
// @Ignore
  external Geolocation.fakeConstructor$();

  /**
   * @param {function(GeolocationPosition)} successCallback
   * @param {(function(GeolocationPositionError)|null)=} opt_errorCallback
   * @param {GeolocationPositionOptions=} opt_options
   */
  getCurrentPosition(successCallback(GeolocationPosition arg1),
      [opt_errorCallback(GeolocationPositionError arg1),
      GeolocationPositionOptions opt_options]);

  /**
   * @param {function(GeolocationPosition)} successCallback
   * @param {(function(GeolocationPositionError)|null)=} opt_errorCallback
   * @param {GeolocationPositionOptions=} opt_options
   * @return {number}
   */
  num watchPosition(successCallback(GeolocationPosition arg1),
      [opt_errorCallback(GeolocationPositionError arg1),
      GeolocationPositionOptions opt_options]);

  /** @param {number} watchId */
  clearWatch(num watchId);
}

/**
 * @constructor
 * @see http://www.w3.org/TR/geolocation-API/#coordinates
 */
@JsName("GeolocationCoordinates")
abstract class GeolocationCoordinates {
// @Ignore
  external GeolocationCoordinates.fakeConstructor$();

  /** @type {number} */
  num latitude;

  /** @type {number} */
  num longitude;

  /** @type {number} */
  num accuracy;

  /** @type {number} */
  num altitude;

  /** @type {number} */
  num altitudeAccuracy;

  /** @type {number} */
  num heading;

  /** @type {number} */
  num speed;
}

/**
 * @constructor
 * @see http://www.w3.org/TR/geolocation-API/#position
 */
@JsName("GeolocationPosition")
abstract class GeolocationPosition {
// @Ignore
  external GeolocationPosition.fakeConstructor$();

  /** @type {GeolocationCoordinates} */
  GeolocationCoordinates coords;

  /** @type {Date} */
  DateTime timestamp;
}

/**
 * @constructor
 * @see http://www.w3.org/TR/geolocation-API/#position-options
 */
@JsName("GeolocationPositionOptions")
abstract class GeolocationPositionOptions {
// @Ignore
  external GeolocationPositionOptions.fakeConstructor$();

  /** @type {boolean} */
  bool enableHighAccuracy;

  /** @type {number} */
  num maximumAge;

  /** @type {number} */
  num timeout;
}

/**
 * @constructor
 * @see http://www.w3.org/TR/geolocation-API/#position-error
 */
@JsName("GeolocationPositionError")
abstract class GeolocationPositionError {
// @Ignore
  external GeolocationPositionError.fakeConstructor$();

  /** @type {number} */
  num code;

  /** @type {string} */
  String message;

  /** @type {number} */
  num UNKNOWN_ERROR;

  /** @type {number} */
  num PERMISSION_DENIED;

  /** @type {number} */
  num POSITION_UNAVAILABLE;

  /** @type {number} */
  num TIMEOUT;
}
