/*
 * Copyright 2010 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for WebGL functions as described at
 * http://www.khronos.org/registry/webgl/specs/latest/
 *
 * This file is current up to the WebGL 1.0.1 spec, including extensions.
 *
 * This relies on html5.js being included for Canvas and Typed Array support.
 *
 * This includes some extensions defined at
 * http://www.khronos.org/registry/webgl/extensions/
 *
 * FROM_EXTERN
 */
@JsName()
library webgl;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "es6.dart" as es6;

import "html5.dart" as html5;

import "w3c_dom2.dart" as w3c_dom2;

import "w3c_event.dart" as w3c_event;

/**
 * @constructor
 * @noalias
 */
@JsName("WebGLRenderingContext")
abstract class WebGLRenderingContext {
// @Ignore
  external WebGLRenderingContext.fakeConstructor$();

  /** @type {number} */
  @JsName(r"TEXTURE31")
  external static num get TEXTURE31$static;

  @JsName(r"TEXTURE31")
  external static set TEXTURE31$static(num value);

  /** @type {number} */
  @JsName(r"VIEWPORT")
  external static num get VIEWPORT$static;

  @JsName(r"VIEWPORT")
  external static set VIEWPORT$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE30")
  external static num get TEXTURE30$static;

  @JsName(r"TEXTURE30")
  external static set TEXTURE30$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_ATTACHMENT")
  external static num get DEPTH_ATTACHMENT$static;

  @JsName(r"DEPTH_ATTACHMENT")
  external static set DEPTH_ATTACHMENT$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_CLEAR_VALUE")
  external static num get DEPTH_CLEAR_VALUE$static;

  @JsName(r"DEPTH_CLEAR_VALUE")
  external static set DEPTH_CLEAR_VALUE$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_MIN_FILTER")
  external static num get TEXTURE_MIN_FILTER$static;

  @JsName(r"TEXTURE_MIN_FILTER")
  external static set TEXTURE_MIN_FILTER$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_INDEX8")
  external static num get STENCIL_INDEX8$static;

  @JsName(r"STENCIL_INDEX8")
  external static set STENCIL_INDEX8$static(num value);

  /** @type {number} */
  @JsName(r"BOOL_VEC4")
  external static num get BOOL_VEC4$static;

  @JsName(r"BOOL_VEC4")
  external static set BOOL_VEC4$static(num value);

  /** @type {number} */
  @JsName(r"BOOL_VEC3")
  external static num get BOOL_VEC3$static;

  @JsName(r"BOOL_VEC3")
  external static set BOOL_VEC3$static(num value);

  /** @type {number} */
  @JsName(r"BOOL_VEC2")
  external static num get BOOL_VEC2$static;

  @JsName(r"BOOL_VEC2")
  external static set BOOL_VEC2$static(num value);

  /** @type {number} */
  @JsName(r"INVALID_VALUE")
  external static num get INVALID_VALUE$static;

  @JsName(r"INVALID_VALUE")
  external static set INVALID_VALUE$static(num value);

  /** @type {number} */
  @JsName(r"UNSIGNED_SHORT_5_6_5")
  external static num get UNSIGNED_SHORT_5_6_5$static;

  @JsName(r"UNSIGNED_SHORT_5_6_5")
  external static set UNSIGNED_SHORT_5_6_5$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE27")
  external static num get TEXTURE27$static;

  @JsName(r"TEXTURE27")
  external static set TEXTURE27$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE28")
  external static num get TEXTURE28$static;

  @JsName(r"TEXTURE28")
  external static set TEXTURE28$static(num value);

  /** @type {number} */
  @JsName(r"SRC_ALPHA")
  external static num get SRC_ALPHA$static;

  @JsName(r"SRC_ALPHA")
  external static set SRC_ALPHA$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE29")
  external static num get TEXTURE29$static;

  @JsName(r"TEXTURE29")
  external static set TEXTURE29$static(num value);

  /** @type {number} */
  @JsName(r"SAMPLE_COVERAGE_INVERT")
  external static num get SAMPLE_COVERAGE_INVERT$static;

  @JsName(r"SAMPLE_COVERAGE_INVERT")
  external static set SAMPLE_COVERAGE_INVERT$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_STENCIL")
  external static num get DEPTH_STENCIL$static;

  @JsName(r"DEPTH_STENCIL")
  external static set DEPTH_STENCIL$static(num value);

  /** @type {number} */
  @JsName(r"SUBPIXEL_BITS")
  external static num get SUBPIXEL_BITS$static;

  @JsName(r"SUBPIXEL_BITS")
  external static set SUBPIXEL_BITS$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_WRITEMASK")
  external static num get DEPTH_WRITEMASK$static;

  @JsName(r"DEPTH_WRITEMASK")
  external static set DEPTH_WRITEMASK$static(num value);

  /** @type {number} */
  @JsName(r"CLAMP_TO_EDGE")
  external static num get CLAMP_TO_EDGE$static;

  @JsName(r"CLAMP_TO_EDGE")
  external static set CLAMP_TO_EDGE$static(num value);

  /** @type {number} */
  @JsName(r"LINEAR")
  external static num get LINEAR$static;

  @JsName(r"LINEAR")
  external static set LINEAR$static(num value);

  /** @type {number} */
  @JsName(r"PACK_ALIGNMENT")
  external static num get PACK_ALIGNMENT$static;

  @JsName(r"PACK_ALIGNMENT")
  external static set PACK_ALIGNMENT$static(num value);

  /** @type {number} */
  @JsName(r"UNPACK_PREMULTIPLY_ALPHA_WEBGL")
  external static num get UNPACK_PREMULTIPLY_ALPHA_WEBGL$static;

  @JsName(r"UNPACK_PREMULTIPLY_ALPHA_WEBGL")
  external static set UNPACK_PREMULTIPLY_ALPHA_WEBGL$static(num value);

  /** @type {number} */
  @JsName(r"RENDERBUFFER")
  external static num get RENDERBUFFER$static;

  @JsName(r"RENDERBUFFER")
  external static set RENDERBUFFER$static(num value);

  /** @type {number} */
  @JsName(r"SAMPLES")
  external static num get SAMPLES$static;

  @JsName(r"SAMPLES")
  external static set SAMPLES$static(num value);

  /** @type {number} */
  @JsName(r"DST_ALPHA")
  external static num get DST_ALPHA$static;

  @JsName(r"DST_ALPHA")
  external static set DST_ALPHA$static(num value);

  /** @type {number} */
  @JsName(r"RENDERBUFFER_WIDTH")
  external static num get RENDERBUFFER_WIDTH$static;

  @JsName(r"RENDERBUFFER_WIDTH")
  external static set RENDERBUFFER_WIDTH$static(num value);

  /** @type {number} */
  @JsName(r"MAX_CUBE_MAP_TEXTURE_SIZE")
  external static num get MAX_CUBE_MAP_TEXTURE_SIZE$static;

  @JsName(r"MAX_CUBE_MAP_TEXTURE_SIZE")
  external static set MAX_CUBE_MAP_TEXTURE_SIZE$static(num value);

  /** @type {number} */
  @JsName(r"ELEMENT_ARRAY_BUFFER_BINDING")
  external static num get ELEMENT_ARRAY_BUFFER_BINDING$static;

  @JsName(r"ELEMENT_ARRAY_BUFFER_BINDING")
  external static set ELEMENT_ARRAY_BUFFER_BINDING$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_BUFFER_BIT")
  external static num get DEPTH_BUFFER_BIT$static;

  @JsName(r"DEPTH_BUFFER_BIT")
  external static set DEPTH_BUFFER_BIT$static(num value);

  /** @type {number} */
  @JsName(r"BLEND")
  external static num get BLEND$static;

  @JsName(r"BLEND")
  external static set BLEND$static(num value);

  /** @type {number} */
  @JsName(r"UNSIGNED_SHORT_4_4_4_4")
  external static num get UNSIGNED_SHORT_4_4_4_4$static;

  @JsName(r"UNSIGNED_SHORT_4_4_4_4")
  external static set UNSIGNED_SHORT_4_4_4_4$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_BACK_WRITEMASK")
  external static num get STENCIL_BACK_WRITEMASK$static;

  @JsName(r"STENCIL_BACK_WRITEMASK")
  external static set STENCIL_BACK_WRITEMASK$static(num value);

  /** @type {number} */
  @JsName(r"RGB5_A1")
  external static num get RGB5_A1$static;

  @JsName(r"RGB5_A1")
  external static set RGB5_A1$static(num value);

  /** @type {number} */
  @JsName(r"ALIASED_LINE_WIDTH_RANGE")
  external static num get ALIASED_LINE_WIDTH_RANGE$static;

  @JsName(r"ALIASED_LINE_WIDTH_RANGE")
  external static set ALIASED_LINE_WIDTH_RANGE$static(num value);

  /** @type {number} */
  @JsName(r"RED_BITS")
  external static num get RED_BITS$static;

  @JsName(r"RED_BITS")
  external static set RED_BITS$static(num value);

  /** @type {number} */
  @JsName(r"BLEND_DST_ALPHA")
  external static num get BLEND_DST_ALPHA$static;

  @JsName(r"BLEND_DST_ALPHA")
  external static set BLEND_DST_ALPHA$static(num value);

  /** @type {number} */
  @JsName(r"BUFFER_SIZE")
  external static num get BUFFER_SIZE$static;

  @JsName(r"BUFFER_SIZE")
  external static set BUFFER_SIZE$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_CUBE_MAP")
  external static num get TEXTURE_CUBE_MAP$static;

  @JsName(r"TEXTURE_CUBE_MAP")
  external static set TEXTURE_CUBE_MAP$static(num value);

  /** @type {number} */
  @JsName(r"UNPACK_COLORSPACE_CONVERSION_WEBGL")
  external static num get UNPACK_COLORSPACE_CONVERSION_WEBGL$static;

  @JsName(r"UNPACK_COLORSPACE_CONVERSION_WEBGL")
  external static set UNPACK_COLORSPACE_CONVERSION_WEBGL$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_BACK_PASS_DEPTH_PASS")
  external static num get STENCIL_BACK_PASS_DEPTH_PASS$static;

  @JsName(r"STENCIL_BACK_PASS_DEPTH_PASS")
  external static set STENCIL_BACK_PASS_DEPTH_PASS$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_FUNC")
  external static num get DEPTH_FUNC$static;

  @JsName(r"DEPTH_FUNC")
  external static set DEPTH_FUNC$static(num value);

  /** @type {number} */
  @JsName(r"BOOL")
  external static num get BOOL$static;

  @JsName(r"BOOL")
  external static set BOOL$static(num value);

  /** @type {number} */
  @JsName(r"SAMPLER_2D")
  external static num get SAMPLER_2D$static;

  @JsName(r"SAMPLER_2D")
  external static set SAMPLER_2D$static(num value);

  /** @type {number} */
  @JsName(r"FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL")
  external static num get FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL$static;

  @JsName(r"FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL")
  external static set FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL$static(num value);

  /** @type {number} */
  @JsName(r"RGBA")
  external static num get RGBA$static;

  @JsName(r"RGBA")
  external static set RGBA$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_TEST")
  external static num get STENCIL_TEST$static;

  @JsName(r"STENCIL_TEST")
  external static set STENCIL_TEST$static(num value);

  /** @type {number} */
  @JsName(r"INT")
  external static num get INT$static;

  @JsName(r"INT")
  external static set INT$static(num value);

  /** @type {number} */
  @JsName(r"RENDERBUFFER_INTERNAL_FORMAT")
  external static num get RENDERBUFFER_INTERNAL_FORMAT$static;

  @JsName(r"RENDERBUFFER_INTERNAL_FORMAT")
  external static set RENDERBUFFER_INTERNAL_FORMAT$static(num value);

  /** @type {number} */
  @JsName(r"POLYGON_OFFSET_UNITS")
  external static num get POLYGON_OFFSET_UNITS$static;

  @JsName(r"POLYGON_OFFSET_UNITS")
  external static set POLYGON_OFFSET_UNITS$static(num value);

  /** @type {number} */
  @JsName(r"LINEAR_MIPMAP_LINEAR")
  external static num get LINEAR_MIPMAP_LINEAR$static;

  @JsName(r"LINEAR_MIPMAP_LINEAR")
  external static set LINEAR_MIPMAP_LINEAR$static(num value);

  /** @type {number} */
  @JsName(r"GREEN_BITS")
  external static num get GREEN_BITS$static;

  @JsName(r"GREEN_BITS")
  external static set GREEN_BITS$static(num value);

  /** @type {number} */
  @JsName(r"RENDERBUFFER_STENCIL_SIZE")
  external static num get RENDERBUFFER_STENCIL_SIZE$static;

  @JsName(r"RENDERBUFFER_STENCIL_SIZE")
  external static set RENDERBUFFER_STENCIL_SIZE$static(num value);

  /** @type {number} */
  @JsName(r"VERTEX_ATTRIB_ARRAY_SIZE")
  external static num get VERTEX_ATTRIB_ARRAY_SIZE$static;

  @JsName(r"VERTEX_ATTRIB_ARRAY_SIZE")
  external static set VERTEX_ATTRIB_ARRAY_SIZE$static(num value);

  /** @type {number} */
  @JsName(r"DONT_CARE")
  external static num get DONT_CARE$static;

  @JsName(r"DONT_CARE")
  external static set DONT_CARE$static(num value);

  /** @type {number} */
  @JsName(r"MAX_TEXTURE_SIZE")
  external static num get MAX_TEXTURE_SIZE$static;

  @JsName(r"MAX_TEXTURE_SIZE")
  external static set MAX_TEXTURE_SIZE$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_BACK_VALUE_MASK")
  external static num get STENCIL_BACK_VALUE_MASK$static;

  @JsName(r"STENCIL_BACK_VALUE_MASK")
  external static set STENCIL_BACK_VALUE_MASK$static(num value);

  /** @type {number} */
  @JsName(r"DELETE_STATUS")
  external static num get DELETE_STATUS$static;

  @JsName(r"DELETE_STATUS")
  external static set DELETE_STATUS$static(num value);

  /** @type {number} */
  @JsName(r"FRONT_AND_BACK")
  external static num get FRONT_AND_BACK$static;

  @JsName(r"FRONT_AND_BACK")
  external static set FRONT_AND_BACK$static(num value);

  /** @type {number} */
  @JsName(r"NONE")
  external static num get NONE$static;

  @JsName(r"NONE")
  external static set NONE$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_BITS")
  external static num get DEPTH_BITS$static;

  @JsName(r"DEPTH_BITS")
  external static set DEPTH_BITS$static(num value);

  /** @type {number} */
  @JsName(r"ARRAY_BUFFER")
  external static num get ARRAY_BUFFER$static;

  @JsName(r"ARRAY_BUFFER")
  external static set ARRAY_BUFFER$static(num value);

  /** @type {number} */
  @JsName(r"REPEAT")
  external static num get REPEAT$static;

  @JsName(r"REPEAT")
  external static set REPEAT$static(num value);

  /** @type {number} */
  @JsName(r"ACTIVE_TEXTURE")
  external static num get ACTIVE_TEXTURE$static;

  @JsName(r"ACTIVE_TEXTURE")
  external static set ACTIVE_TEXTURE$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_CUBE_MAP_POSITIVE_Z")
  external static num get TEXTURE_CUBE_MAP_POSITIVE_Z$static;

  @JsName(r"TEXTURE_CUBE_MAP_POSITIVE_Z")
  external static set TEXTURE_CUBE_MAP_POSITIVE_Z$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_CUBE_MAP_POSITIVE_Y")
  external static num get TEXTURE_CUBE_MAP_POSITIVE_Y$static;

  @JsName(r"TEXTURE_CUBE_MAP_POSITIVE_Y")
  external static set TEXTURE_CUBE_MAP_POSITIVE_Y$static(num value);

  /** @type {number} */
  @JsName(r"RENDERBUFFER_ALPHA_SIZE")
  external static num get RENDERBUFFER_ALPHA_SIZE$static;

  @JsName(r"RENDERBUFFER_ALPHA_SIZE")
  external static set RENDERBUFFER_ALPHA_SIZE$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_CUBE_MAP_POSITIVE_X")
  external static num get TEXTURE_CUBE_MAP_POSITIVE_X$static;

  @JsName(r"TEXTURE_CUBE_MAP_POSITIVE_X")
  external static set TEXTURE_CUBE_MAP_POSITIVE_X$static(num value);

  /** @type {number} */
  @JsName(r"COMPRESSED_TEXTURE_FORMATS")
  external static num get COMPRESSED_TEXTURE_FORMATS$static;

  @JsName(r"COMPRESSED_TEXTURE_FORMATS")
  external static set COMPRESSED_TEXTURE_FORMATS$static(num value);

  /** @type {number} */
  @JsName(r"RENDERBUFFER_GREEN_SIZE")
  external static num get RENDERBUFFER_GREEN_SIZE$static;

  @JsName(r"RENDERBUFFER_GREEN_SIZE")
  external static set RENDERBUFFER_GREEN_SIZE$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_PASS_DEPTH_FAIL")
  external static num get STENCIL_PASS_DEPTH_FAIL$static;

  @JsName(r"STENCIL_PASS_DEPTH_FAIL")
  external static set STENCIL_PASS_DEPTH_FAIL$static(num value);

  /** @type {number} */
  @JsName(r"BUFFER_USAGE")
  external static num get BUFFER_USAGE$static;

  @JsName(r"BUFFER_USAGE")
  external static set BUFFER_USAGE$static(num value);

  /** @type {number} */
  @JsName(r"MAX_COMBINED_TEXTURE_IMAGE_UNITS")
  external static num get MAX_COMBINED_TEXTURE_IMAGE_UNITS$static;

  @JsName(r"MAX_COMBINED_TEXTURE_IMAGE_UNITS")
  external static set MAX_COMBINED_TEXTURE_IMAGE_UNITS$static(num value);

  /** @type {number} */
  @JsName(r"NICEST")
  external static num get NICEST$static;

  @JsName(r"NICEST")
  external static set NICEST$static(num value);

  /** @type {number} */
  @JsName(r"TRIANGLES")
  external static num get TRIANGLES$static;

  @JsName(r"TRIANGLES")
  external static set TRIANGLES$static(num value);

  /** @type {number} */
  @JsName(r"CURRENT_PROGRAM")
  external static num get CURRENT_PROGRAM$static;

  @JsName(r"CURRENT_PROGRAM")
  external static set CURRENT_PROGRAM$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_COMPONENT16")
  external static num get DEPTH_COMPONENT16$static;

  @JsName(r"DEPTH_COMPONENT16")
  external static set DEPTH_COMPONENT16$static(num value);

  /** @type {number} */
  @JsName(r"CONSTANT_ALPHA")
  external static num get CONSTANT_ALPHA$static;

  @JsName(r"CONSTANT_ALPHA")
  external static set CONSTANT_ALPHA$static(num value);

  /** @type {number} */
  @JsName(r"FRAMEBUFFER_ATTACHMENT_OBJECT_NAME")
  external static num get FRAMEBUFFER_ATTACHMENT_OBJECT_NAME$static;

  @JsName(r"FRAMEBUFFER_ATTACHMENT_OBJECT_NAME")
  external static set FRAMEBUFFER_ATTACHMENT_OBJECT_NAME$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_CUBE_MAP_NEGATIVE_Y")
  external static num get TEXTURE_CUBE_MAP_NEGATIVE_Y$static;

  @JsName(r"TEXTURE_CUBE_MAP_NEGATIVE_Y")
  external static set TEXTURE_CUBE_MAP_NEGATIVE_Y$static(num value);

  /** @type {number} */
  @JsName(r"LINES")
  external static num get LINES$static;

  @JsName(r"LINES")
  external static set LINES$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_CUBE_MAP_NEGATIVE_Z")
  external static num get TEXTURE_CUBE_MAP_NEGATIVE_Z$static;

  @JsName(r"TEXTURE_CUBE_MAP_NEGATIVE_Z")
  external static set TEXTURE_CUBE_MAP_NEGATIVE_Z$static(num value);

  /** @type {number} */
  @JsName(r"COLOR_ATTACHMENT0")
  external static num get COLOR_ATTACHMENT0$static;

  @JsName(r"COLOR_ATTACHMENT0")
  external static set COLOR_ATTACHMENT0$static(num value);

  /** @type {number} */
  @JsName(r"VERSION")
  external static num get VERSION$static;

  @JsName(r"VERSION")
  external static set VERSION$static(num value);

  /** @type {number} */
  @JsName(r"FRAMEBUFFER_COMPLETE")
  external static num get FRAMEBUFFER_COMPLETE$static;

  @JsName(r"FRAMEBUFFER_COMPLETE")
  external static set FRAMEBUFFER_COMPLETE$static(num value);

  /** @type {number} */
  @JsName(r"FLOAT")
  external static num get FLOAT$static;

  @JsName(r"FLOAT")
  external static set FLOAT$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_FAIL")
  external static num get STENCIL_FAIL$static;

  @JsName(r"STENCIL_FAIL")
  external static set STENCIL_FAIL$static(num value);

  /** @type {number} */
  @JsName(r"RENDERBUFFER_RED_SIZE")
  external static num get RENDERBUFFER_RED_SIZE$static;

  @JsName(r"RENDERBUFFER_RED_SIZE")
  external static set RENDERBUFFER_RED_SIZE$static(num value);

  /** @type {number} */
  @JsName(r"UNSIGNED_SHORT_5_5_5_1")
  external static num get UNSIGNED_SHORT_5_5_5_1$static;

  @JsName(r"UNSIGNED_SHORT_5_5_5_1")
  external static set UNSIGNED_SHORT_5_5_5_1$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_RANGE")
  external static num get DEPTH_RANGE$static;

  @JsName(r"DEPTH_RANGE")
  external static set DEPTH_RANGE$static(num value);

  /** @type {number} */
  @JsName(r"ZERO")
  external static num get ZERO$static;

  @JsName(r"ZERO")
  external static set ZERO$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_CUBE_MAP_NEGATIVE_X")
  external static num get TEXTURE_CUBE_MAP_NEGATIVE_X$static;

  @JsName(r"TEXTURE_CUBE_MAP_NEGATIVE_X")
  external static set TEXTURE_CUBE_MAP_NEGATIVE_X$static(num value);

  /** @type {number} */
  @JsName(r"RENDERBUFFER_BINDING")
  external static num get RENDERBUFFER_BINDING$static;

  @JsName(r"RENDERBUFFER_BINDING")
  external static set RENDERBUFFER_BINDING$static(num value);

  /** @type {number} */
  @JsName(r"ATTACHED_SHADERS")
  external static num get ATTACHED_SHADERS$static;

  @JsName(r"ATTACHED_SHADERS")
  external static set ATTACHED_SHADERS$static(num value);

  /** @type {number} */
  @JsName(r"MAX_VERTEX_UNIFORM_VECTORS")
  external static num get MAX_VERTEX_UNIFORM_VECTORS$static;

  @JsName(r"MAX_VERTEX_UNIFORM_VECTORS")
  external static set MAX_VERTEX_UNIFORM_VECTORS$static(num value);

  /** @type {number} */
  @JsName(r"ELEMENT_ARRAY_BUFFER")
  external static num get ELEMENT_ARRAY_BUFFER$static;

  @JsName(r"ELEMENT_ARRAY_BUFFER")
  external static set ELEMENT_ARRAY_BUFFER$static(num value);

  /** @type {number} */
  @JsName(r"GEQUAL")
  external static num get GEQUAL$static;

  @JsName(r"GEQUAL")
  external static set GEQUAL$static(num value);

  /** @type {number} */
  @JsName(r"REPLACE")
  external static num get REPLACE$static;

  @JsName(r"REPLACE")
  external static set REPLACE$static(num value);

  /** @type {number} */
  @JsName(r"ALPHA_BITS")
  external static num get ALPHA_BITS$static;

  @JsName(r"ALPHA_BITS")
  external static set ALPHA_BITS$static(num value);

  /** @type {number} */
  @JsName(r"UNSIGNED_SHORT")
  external static num get UNSIGNED_SHORT$static;

  @JsName(r"UNSIGNED_SHORT")
  external static set UNSIGNED_SHORT$static(num value);

  /** @type {number} */
  @JsName(r"SAMPLE_COVERAGE")
  external static num get SAMPLE_COVERAGE$static;

  @JsName(r"SAMPLE_COVERAGE")
  external static set SAMPLE_COVERAGE$static(num value);

  /** @type {number} */
  @JsName(r"FRAMEBUFFER_BINDING")
  external static num get FRAMEBUFFER_BINDING$static;

  @JsName(r"FRAMEBUFFER_BINDING")
  external static set FRAMEBUFFER_BINDING$static(num value);

  /** @type {number} */
  @JsName(r"COMPILE_STATUS")
  external static num get COMPILE_STATUS$static;

  @JsName(r"COMPILE_STATUS")
  external static set COMPILE_STATUS$static(num value);

  /** @type {number} */
  @JsName(r"COLOR_WRITEMASK")
  external static num get COLOR_WRITEMASK$static;

  @JsName(r"COLOR_WRITEMASK")
  external static set COLOR_WRITEMASK$static(num value);

  /** @type {number} */
  @JsName(r"VERTEX_ATTRIB_ARRAY_POINTER")
  external static num get VERTEX_ATTRIB_ARRAY_POINTER$static;

  @JsName(r"VERTEX_ATTRIB_ARRAY_POINTER")
  external static set VERTEX_ATTRIB_ARRAY_POINTER$static(num value);

  /** @type {number} */
  @JsName(r"FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT")
  external static num get FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT$static;

  @JsName(r"FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT")
  external static set FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT$static(
      num value);

  /** @type {number} */
  @JsName(r"GENERATE_MIPMAP_HINT")
  external static num get GENERATE_MIPMAP_HINT$static;

  @JsName(r"GENERATE_MIPMAP_HINT")
  external static set GENERATE_MIPMAP_HINT$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_MAG_FILTER")
  external static num get TEXTURE_MAG_FILTER$static;

  @JsName(r"TEXTURE_MAG_FILTER")
  external static set TEXTURE_MAG_FILTER$static(num value);

  /** @type {number} */
  @JsName(r"UNSIGNED_BYTE")
  external static num get UNSIGNED_BYTE$static;

  @JsName(r"UNSIGNED_BYTE")
  external static set UNSIGNED_BYTE$static(num value);

  /** @type {number} */
  @JsName(r"MAX_TEXTURE_IMAGE_UNITS")
  external static num get MAX_TEXTURE_IMAGE_UNITS$static;

  @JsName(r"MAX_TEXTURE_IMAGE_UNITS")
  external static set MAX_TEXTURE_IMAGE_UNITS$static(num value);

  /** @type {number} */
  @JsName(r"MAX_VERTEX_TEXTURE_IMAGE_UNITS")
  external static num get MAX_VERTEX_TEXTURE_IMAGE_UNITS$static;

  @JsName(r"MAX_VERTEX_TEXTURE_IMAGE_UNITS")
  external static set MAX_VERTEX_TEXTURE_IMAGE_UNITS$static(num value);

  /** @type {number} */
  @JsName(r"MAX_RENDERBUFFER_SIZE")
  external static num get MAX_RENDERBUFFER_SIZE$static;

  @JsName(r"MAX_RENDERBUFFER_SIZE")
  external static set MAX_RENDERBUFFER_SIZE$static(num value);

  /** @type {number} */
  @JsName(r"VERTEX_ATTRIB_ARRAY_BUFFER_BINDING")
  external static num get VERTEX_ATTRIB_ARRAY_BUFFER_BINDING$static;

  @JsName(r"VERTEX_ATTRIB_ARRAY_BUFFER_BINDING")
  external static set VERTEX_ATTRIB_ARRAY_BUFFER_BINDING$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE12")
  external static num get TEXTURE12$static;

  @JsName(r"TEXTURE12")
  external static set TEXTURE12$static(num value);

  /** @type {number} */
  @JsName(r"INCR_WRAP")
  external static num get INCR_WRAP$static;

  @JsName(r"INCR_WRAP")
  external static set INCR_WRAP$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE13")
  external static num get TEXTURE13$static;

  @JsName(r"TEXTURE13")
  external static set TEXTURE13$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE14")
  external static num get TEXTURE14$static;

  @JsName(r"TEXTURE14")
  external static set TEXTURE14$static(num value);

  /** @type {number} */
  @JsName(r"INT_VEC4")
  external static num get INT_VEC4$static;

  @JsName(r"INT_VEC4")
  external static set INT_VEC4$static(num value);

  /** @type {number} */
  @JsName(r"SAMPLE_COVERAGE_VALUE")
  external static num get SAMPLE_COVERAGE_VALUE$static;

  @JsName(r"SAMPLE_COVERAGE_VALUE")
  external static set SAMPLE_COVERAGE_VALUE$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE15")
  external static num get TEXTURE15$static;

  @JsName(r"TEXTURE15")
  external static set TEXTURE15$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE10")
  external static num get TEXTURE10$static;

  @JsName(r"TEXTURE10")
  external static set TEXTURE10$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE11")
  external static num get TEXTURE11$static;

  @JsName(r"TEXTURE11")
  external static set TEXTURE11$static(num value);

  /** @type {number} */
  @JsName(r"NO_ERROR")
  external static num get NO_ERROR$static;

  @JsName(r"NO_ERROR")
  external static set NO_ERROR$static(num value);

  /** @type {number} */
  @JsName(r"SHORT")
  external static num get SHORT$static;

  @JsName(r"SHORT")
  external static set SHORT$static(num value);

  /** @type {number} */
  @JsName(r"INT_VEC3")
  external static num get INT_VEC3$static;

  @JsName(r"INT_VEC3")
  external static set INT_VEC3$static(num value);

  /** @type {number} */
  @JsName(r"INT_VEC2")
  external static num get INT_VEC2$static;

  @JsName(r"INT_VEC2")
  external static set INT_VEC2$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_ATTACHMENT")
  external static num get STENCIL_ATTACHMENT$static;

  @JsName(r"STENCIL_ATTACHMENT")
  external static set STENCIL_ATTACHMENT$static(num value);

  /** @type {number} */
  @JsName(r"ALIASED_POINT_SIZE_RANGE")
  external static num get ALIASED_POINT_SIZE_RANGE$static;

  @JsName(r"ALIASED_POINT_SIZE_RANGE")
  external static set ALIASED_POINT_SIZE_RANGE$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_VALUE_MASK")
  external static num get STENCIL_VALUE_MASK$static;

  @JsName(r"STENCIL_VALUE_MASK")
  external static set STENCIL_VALUE_MASK$static(num value);

  /** @type {number} */
  @JsName(r"BROWSER_DEFAULT_WEBGL")
  external static num get BROWSER_DEFAULT_WEBGL$static;

  @JsName(r"BROWSER_DEFAULT_WEBGL")
  external static set BROWSER_DEFAULT_WEBGL$static(num value);

  /** @type {number} */
  @JsName(r"SCISSOR_BOX")
  external static num get SCISSOR_BOX$static;

  @JsName(r"SCISSOR_BOX")
  external static set SCISSOR_BOX$static(num value);

  /** @type {number} */
  @JsName(r"BLEND_SRC_ALPHA")
  external static num get BLEND_SRC_ALPHA$static;

  @JsName(r"BLEND_SRC_ALPHA")
  external static set BLEND_SRC_ALPHA$static(num value);

  /** @type {number} */
  @JsName(r"CW")
  external static num get CW$static;

  @JsName(r"CW")
  external static set CW$static(num value);

  /** @type {number} */
  @JsName(r"TRIANGLE_FAN")
  external static num get TRIANGLE_FAN$static;

  @JsName(r"TRIANGLE_FAN")
  external static set TRIANGLE_FAN$static(num value);

  /** @type {number} */
  @JsName(r"FRAMEBUFFER_INCOMPLETE_ATTACHMENT")
  external static num get FRAMEBUFFER_INCOMPLETE_ATTACHMENT$static;

  @JsName(r"FRAMEBUFFER_INCOMPLETE_ATTACHMENT")
  external static set FRAMEBUFFER_INCOMPLETE_ATTACHMENT$static(num value);

  /** @type {number} */
  @JsName(r"BLEND_EQUATION")
  external static num get BLEND_EQUATION$static;

  @JsName(r"BLEND_EQUATION")
  external static set BLEND_EQUATION$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE25")
  external static num get TEXTURE25$static;

  @JsName(r"TEXTURE25")
  external static set TEXTURE25$static(num value);

  /** @type {number} */
  @JsName(r"UNPACK_ALIGNMENT")
  external static num get UNPACK_ALIGNMENT$static;

  @JsName(r"UNPACK_ALIGNMENT")
  external static set UNPACK_ALIGNMENT$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE26")
  external static num get TEXTURE26$static;

  @JsName(r"TEXTURE26")
  external static set TEXTURE26$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE23")
  external static num get TEXTURE23$static;

  @JsName(r"TEXTURE23")
  external static set TEXTURE23$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE24")
  external static num get TEXTURE24$static;

  @JsName(r"TEXTURE24")
  external static set TEXTURE24$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE21")
  external static num get TEXTURE21$static;

  @JsName(r"TEXTURE21")
  external static set TEXTURE21$static(num value);

  /** @type {number} */
  @JsName(r"FLOAT_VEC4")
  external static num get FLOAT_VEC4$static;

  @JsName(r"FLOAT_VEC4")
  external static set FLOAT_VEC4$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE22")
  external static num get TEXTURE22$static;

  @JsName(r"TEXTURE22")
  external static set TEXTURE22$static(num value);

  /** @type {number} */
  @JsName(r"FLOAT_VEC3")
  external static num get FLOAT_VEC3$static;

  @JsName(r"FLOAT_VEC3")
  external static set FLOAT_VEC3$static(num value);

  /** @type {number} */
  @JsName(r"FLOAT_VEC2")
  external static num get FLOAT_VEC2$static;

  @JsName(r"FLOAT_VEC2")
  external static set FLOAT_VEC2$static(num value);

  /** @type {number} */
  @JsName(r"LOW_FLOAT")
  external static num get LOW_FLOAT$static;

  @JsName(r"LOW_FLOAT")
  external static set LOW_FLOAT$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE20")
  external static num get TEXTURE20$static;

  @JsName(r"TEXTURE20")
  external static set TEXTURE20$static(num value);

  /** @type {number} */
  @JsName(r"INVALID_OPERATION")
  external static num get INVALID_OPERATION$static;

  @JsName(r"INVALID_OPERATION")
  external static set INVALID_OPERATION$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_BINDING_CUBE_MAP")
  external static num get TEXTURE_BINDING_CUBE_MAP$static;

  @JsName(r"TEXTURE_BINDING_CUBE_MAP")
  external static set TEXTURE_BINDING_CUBE_MAP$static(num value);

  /** @type {number} */
  @JsName(r"RGBA4")
  external static num get RGBA4$static;

  @JsName(r"RGBA4")
  external static set RGBA4$static(num value);

  /** @type {number} */
  @JsName(r"RGB565")
  external static num get RGB565$static;

  @JsName(r"RGB565")
  external static set RGB565$static(num value);

  /** @type {number} */
  @JsName(r"DITHER")
  external static num get DITHER$static;

  @JsName(r"DITHER")
  external static set DITHER$static(num value);

  /** @type {number} */
  @JsName(r"SAMPLE_ALPHA_TO_COVERAGE")
  external static num get SAMPLE_ALPHA_TO_COVERAGE$static;

  @JsName(r"SAMPLE_ALPHA_TO_COVERAGE")
  external static set SAMPLE_ALPHA_TO_COVERAGE$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE19")
  external static num get TEXTURE19$static;

  @JsName(r"TEXTURE19")
  external static set TEXTURE19$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE18")
  external static num get TEXTURE18$static;

  @JsName(r"TEXTURE18")
  external static set TEXTURE18$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE17")
  external static num get TEXTURE17$static;

  @JsName(r"TEXTURE17")
  external static set TEXTURE17$static(num value);

  /** @type {number} */
  @JsName(r"FRAMEBUFFER_UNSUPPORTED")
  external static num get FRAMEBUFFER_UNSUPPORTED$static;

  @JsName(r"FRAMEBUFFER_UNSUPPORTED")
  external static set FRAMEBUFFER_UNSUPPORTED$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE16")
  external static num get TEXTURE16$static;

  @JsName(r"TEXTURE16")
  external static set TEXTURE16$static(num value);

  /** @type {number} */
  @JsName(r"NEVER")
  external static num get NEVER$static;

  @JsName(r"NEVER")
  external static set NEVER$static(num value);

  /** @type {number} */
  @JsName(r"INVALID_ENUM")
  external static num get INVALID_ENUM$static;

  @JsName(r"INVALID_ENUM")
  external static set INVALID_ENUM$static(num value);

  /** @type {number} */
  @JsName(r"VERTEX_ATTRIB_ARRAY_TYPE")
  external static num get VERTEX_ATTRIB_ARRAY_TYPE$static;

  @JsName(r"VERTEX_ATTRIB_ARRAY_TYPE")
  external static set VERTEX_ATTRIB_ARRAY_TYPE$static(num value);

  /** @type {number} */
  @JsName(r"ONE_MINUS_DST_COLOR")
  external static num get ONE_MINUS_DST_COLOR$static;

  @JsName(r"ONE_MINUS_DST_COLOR")
  external static set ONE_MINUS_DST_COLOR$static(num value);

  /** @type {number} */
  @JsName(r"MEDIUM_INT")
  external static num get MEDIUM_INT$static;

  @JsName(r"MEDIUM_INT")
  external static set MEDIUM_INT$static(num value);

  /** @type {number} */
  @JsName(r"TRIANGLE_STRIP")
  external static num get TRIANGLE_STRIP$static;

  @JsName(r"TRIANGLE_STRIP")
  external static set TRIANGLE_STRIP$static(num value);

  /** @type {number} */
  @JsName(r"RGB")
  external static num get RGB$static;

  @JsName(r"RGB")
  external static set RGB$static(num value);

  /** @type {number} */
  @JsName(r"LOW_INT")
  external static num get LOW_INT$static;

  @JsName(r"LOW_INT")
  external static set LOW_INT$static(num value);

  /** @type {number} */
  @JsName(r"MAX_VARYING_VECTORS")
  external static num get MAX_VARYING_VECTORS$static;

  @JsName(r"MAX_VARYING_VECTORS")
  external static set MAX_VARYING_VECTORS$static(num value);

  /** @type {number} */
  @JsName(r"DST_COLOR")
  external static num get DST_COLOR$static;

  @JsName(r"DST_COLOR")
  external static set DST_COLOR$static(num value);

  /** @type {number} */
  @JsName(r"ONE")
  external static num get ONE$static;

  @JsName(r"ONE")
  external static set ONE$static(num value);

  /** @type {number} */
  @JsName(r"BLUE_BITS")
  external static num get BLUE_BITS$static;

  @JsName(r"BLUE_BITS")
  external static set BLUE_BITS$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_FUNC")
  external static num get STENCIL_FUNC$static;

  @JsName(r"STENCIL_FUNC")
  external static set STENCIL_FUNC$static(num value);

  /** @type {number} */
  @JsName(r"FRONT_FACE")
  external static num get FRONT_FACE$static;

  @JsName(r"FRONT_FACE")
  external static set FRONT_FACE$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_BITS")
  external static num get STENCIL_BITS$static;

  @JsName(r"STENCIL_BITS")
  external static set STENCIL_BITS$static(num value);

  /** @type {number} */
  @JsName(r"NOTEQUAL")
  external static num get NOTEQUAL$static;

  @JsName(r"NOTEQUAL")
  external static set NOTEQUAL$static(num value);

  /** @type {number} */
  @JsName(r"LEQUAL")
  external static num get LEQUAL$static;

  @JsName(r"LEQUAL")
  external static set LEQUAL$static(num value);

  /** @type {number} */
  @JsName(r"BACK")
  external static num get BACK$static;

  @JsName(r"BACK")
  external static set BACK$static(num value);

  /** @type {number} */
  @JsName(r"GREATER")
  external static num get GREATER$static;

  @JsName(r"GREATER")
  external static set GREATER$static(num value);

  /** @type {number} */
  @JsName(r"SAMPLE_BUFFERS")
  external static num get SAMPLE_BUFFERS$static;

  @JsName(r"SAMPLE_BUFFERS")
  external static set SAMPLE_BUFFERS$static(num value);

  /** @type {number} */
  @JsName(r"ALWAYS")
  external static num get ALWAYS$static;

  @JsName(r"ALWAYS")
  external static set ALWAYS$static(num value);

  /** @type {number} */
  @JsName(r"INCR")
  external static num get INCR$static;

  @JsName(r"INCR")
  external static set INCR$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_PASS_DEPTH_PASS")
  external static num get STENCIL_PASS_DEPTH_PASS$static;

  @JsName(r"STENCIL_PASS_DEPTH_PASS")
  external static set STENCIL_PASS_DEPTH_PASS$static(num value);

  /** @type {number} */
  @JsName(r"STREAM_DRAW")
  external static num get STREAM_DRAW$static;

  @JsName(r"STREAM_DRAW")
  external static set STREAM_DRAW$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_BUFFER_BIT")
  external static num get STENCIL_BUFFER_BIT$static;

  @JsName(r"STENCIL_BUFFER_BIT")
  external static set STENCIL_BUFFER_BIT$static(num value);

  /** @type {number} */
  @JsName(r"SHADER_TYPE")
  external static num get SHADER_TYPE$static;

  @JsName(r"SHADER_TYPE")
  external static set SHADER_TYPE$static(num value);

  /** @type {number} */
  @JsName(r"LESS")
  external static num get LESS$static;

  @JsName(r"LESS")
  external static set LESS$static(num value);

  /** @type {number} */
  @JsName(r"SAMPLER_CUBE")
  external static num get SAMPLER_CUBE$static;

  @JsName(r"SAMPLER_CUBE")
  external static set SAMPLER_CUBE$static(num value);

  /** @type {number} */
  @JsName(r"INVERT")
  external static num get INVERT$static;

  @JsName(r"INVERT")
  external static set INVERT$static(num value);

  /** @type {number} */
  @JsName(r"ARRAY_BUFFER_BINDING")
  external static num get ARRAY_BUFFER_BINDING$static;

  @JsName(r"ARRAY_BUFFER_BINDING")
  external static set ARRAY_BUFFER_BINDING$static(num value);

  /** @type {number} */
  @JsName(r"RENDERBUFFER_HEIGHT")
  external static num get RENDERBUFFER_HEIGHT$static;

  @JsName(r"RENDERBUFFER_HEIGHT")
  external static set RENDERBUFFER_HEIGHT$static(num value);

  /** @type {number} */
  @JsName(r"INVALID_FRAMEBUFFER_OPERATION")
  external static num get INVALID_FRAMEBUFFER_OPERATION$static;

  @JsName(r"INVALID_FRAMEBUFFER_OPERATION")
  external static set INVALID_FRAMEBUFFER_OPERATION$static(num value);

  /** @type {number} */
  @JsName(r"POLYGON_OFFSET_FACTOR")
  external static num get POLYGON_OFFSET_FACTOR$static;

  @JsName(r"POLYGON_OFFSET_FACTOR")
  external static set POLYGON_OFFSET_FACTOR$static(num value);

  /** @type {number} */
  @JsName(r"BLEND_EQUATION_ALPHA")
  external static num get BLEND_EQUATION_ALPHA$static;

  @JsName(r"BLEND_EQUATION_ALPHA")
  external static set BLEND_EQUATION_ALPHA$static(num value);

  /** @type {number} */
  @JsName(r"BLEND_EQUATION_RGB")
  external static num get BLEND_EQUATION_RGB$static;

  @JsName(r"BLEND_EQUATION_RGB")
  external static set BLEND_EQUATION_RGB$static(num value);

  /** @type {number} */
  @JsName(r"FLOAT_MAT2")
  external static num get FLOAT_MAT2$static;

  @JsName(r"FLOAT_MAT2")
  external static set FLOAT_MAT2$static(num value);

  /** @type {number} */
  @JsName(r"FLOAT_MAT3")
  external static num get FLOAT_MAT3$static;

  @JsName(r"FLOAT_MAT3")
  external static set FLOAT_MAT3$static(num value);

  /** @type {number} */
  @JsName(r"LINE_STRIP")
  external static num get LINE_STRIP$static;

  @JsName(r"LINE_STRIP")
  external static set LINE_STRIP$static(num value);

  /** @type {number} */
  @JsName(r"FLOAT_MAT4")
  external static num get FLOAT_MAT4$static;

  @JsName(r"FLOAT_MAT4")
  external static set FLOAT_MAT4$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_BINDING_2D")
  external static num get TEXTURE_BINDING_2D$static;

  @JsName(r"TEXTURE_BINDING_2D")
  external static set TEXTURE_BINDING_2D$static(num value);

  /** @type {number} */
  @JsName(r"LINEAR_MIPMAP_NEAREST")
  external static num get LINEAR_MIPMAP_NEAREST$static;

  @JsName(r"LINEAR_MIPMAP_NEAREST")
  external static set LINEAR_MIPMAP_NEAREST$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_WRAP_S")
  external static num get TEXTURE_WRAP_S$static;

  @JsName(r"TEXTURE_WRAP_S")
  external static set TEXTURE_WRAP_S$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_WRAP_T")
  external static num get TEXTURE_WRAP_T$static;

  @JsName(r"TEXTURE_WRAP_T")
  external static set TEXTURE_WRAP_T$static(num value);

  /** @type {number} */
  @JsName(r"ACTIVE_UNIFORMS")
  external static num get ACTIVE_UNIFORMS$static;

  @JsName(r"ACTIVE_UNIFORMS")
  external static set ACTIVE_UNIFORMS$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_CLEAR_VALUE")
  external static num get STENCIL_CLEAR_VALUE$static;

  @JsName(r"STENCIL_CLEAR_VALUE")
  external static set STENCIL_CLEAR_VALUE$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_STENCIL_ATTACHMENT")
  external static num get DEPTH_STENCIL_ATTACHMENT$static;

  @JsName(r"DEPTH_STENCIL_ATTACHMENT")
  external static set DEPTH_STENCIL_ATTACHMENT$static(num value);

  /** @type {number} */
  @JsName(r"ONE_MINUS_CONSTANT_ALPHA")
  external static num get ONE_MINUS_CONSTANT_ALPHA$static;

  @JsName(r"ONE_MINUS_CONSTANT_ALPHA")
  external static set ONE_MINUS_CONSTANT_ALPHA$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE2")
  external static num get TEXTURE2$static;

  @JsName(r"TEXTURE2")
  external static set TEXTURE2$static(num value);

  /** @type {number} */
  @JsName(r"OUT_OF_MEMORY")
  external static num get OUT_OF_MEMORY$static;

  @JsName(r"OUT_OF_MEMORY")
  external static set OUT_OF_MEMORY$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE1")
  external static num get TEXTURE1$static;

  @JsName(r"TEXTURE1")
  external static set TEXTURE1$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE0")
  external static num get TEXTURE0$static;

  @JsName(r"TEXTURE0")
  external static set TEXTURE0$static(num value);

  /** @type {number} */
  @JsName(r"FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE")
  external static num get FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE$static;

  @JsName(r"FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE")
  external static set FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE6")
  external static num get TEXTURE6$static;

  @JsName(r"TEXTURE6")
  external static set TEXTURE6$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE5")
  external static num get TEXTURE5$static;

  @JsName(r"TEXTURE5")
  external static set TEXTURE5$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE4")
  external static num get TEXTURE4$static;

  @JsName(r"TEXTURE4")
  external static set TEXTURE4$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE3")
  external static num get TEXTURE3$static;

  @JsName(r"TEXTURE3")
  external static set TEXTURE3$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE9")
  external static num get TEXTURE9$static;

  @JsName(r"TEXTURE9")
  external static set TEXTURE9$static(num value);

  /** @type {number} */
  @JsName(r"ALPHA")
  external static num get ALPHA$static;

  @JsName(r"ALPHA")
  external static set ALPHA$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE8")
  external static num get TEXTURE8$static;

  @JsName(r"TEXTURE8")
  external static set TEXTURE8$static(num value);

  /** @type {number} */
  @JsName(r"DECR_WRAP")
  external static num get DECR_WRAP$static;

  @JsName(r"DECR_WRAP")
  external static set DECR_WRAP$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE7")
  external static num get TEXTURE7$static;

  @JsName(r"TEXTURE7")
  external static set TEXTURE7$static(num value);

  /** @type {number} */
  @JsName(r"LINK_STATUS")
  external static num get LINK_STATUS$static;

  @JsName(r"LINK_STATUS")
  external static set LINK_STATUS$static(num value);

  /** @type {number} */
  @JsName(r"ONE_MINUS_DST_ALPHA")
  external static num get ONE_MINUS_DST_ALPHA$static;

  @JsName(r"ONE_MINUS_DST_ALPHA")
  external static set ONE_MINUS_DST_ALPHA$static(num value);

  /** @type {number} */
  @JsName(r"MAX_VIEWPORT_DIMS")
  external static num get MAX_VIEWPORT_DIMS$static;

  @JsName(r"MAX_VIEWPORT_DIMS")
  external static set MAX_VIEWPORT_DIMS$static(num value);

  /** @type {number} */
  @JsName(r"VERTEX_SHADER")
  external static num get VERTEX_SHADER$static;

  @JsName(r"VERTEX_SHADER")
  external static set VERTEX_SHADER$static(num value);

  /** @type {number} */
  @JsName(r"FRONT")
  external static num get FRONT$static;

  @JsName(r"FRONT")
  external static set FRONT$static(num value);

  /** @type {number} */
  @JsName(r"CULL_FACE_MODE")
  external static num get CULL_FACE_MODE$static;

  @JsName(r"CULL_FACE_MODE")
  external static set CULL_FACE_MODE$static(num value);

  /** @type {number} */
  @JsName(r"MAX_VERTEX_ATTRIBS")
  external static num get MAX_VERTEX_ATTRIBS$static;

  @JsName(r"MAX_VERTEX_ATTRIBS")
  external static set MAX_VERTEX_ATTRIBS$static(num value);

  /** @type {number} */
  @JsName(r"VERTEX_ATTRIB_ARRAY_NORMALIZED")
  external static num get VERTEX_ATTRIB_ARRAY_NORMALIZED$static;

  @JsName(r"VERTEX_ATTRIB_ARRAY_NORMALIZED")
  external static set VERTEX_ATTRIB_ARRAY_NORMALIZED$static(num value);

  /** @type {number} */
  @JsName(r"CONTEXT_LOST_WEBGL")
  external static num get CONTEXT_LOST_WEBGL$static;

  @JsName(r"CONTEXT_LOST_WEBGL")
  external static set CONTEXT_LOST_WEBGL$static(num value);

  /** @type {number} */
  @JsName(r"MEDIUM_FLOAT")
  external static num get MEDIUM_FLOAT$static;

  @JsName(r"MEDIUM_FLOAT")
  external static set MEDIUM_FLOAT$static(num value);

  /** @type {number} */
  @JsName(r"FASTEST")
  external static num get FASTEST$static;

  @JsName(r"FASTEST")
  external static set FASTEST$static(num value);

  /** @type {number} */
  @JsName(r"ACTIVE_ATTRIBUTES")
  external static num get ACTIVE_ATTRIBUTES$static;

  @JsName(r"ACTIVE_ATTRIBUTES")
  external static set ACTIVE_ATTRIBUTES$static(num value);

  /** @type {number} */
  @JsName(r"VENDOR")
  external static num get VENDOR$static;

  @JsName(r"VENDOR")
  external static set VENDOR$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_BACK_REF")
  external static num get STENCIL_BACK_REF$static;

  @JsName(r"STENCIL_BACK_REF")
  external static set STENCIL_BACK_REF$static(num value);

  /** @type {number} */
  @JsName(r"ONE_MINUS_CONSTANT_COLOR")
  external static num get ONE_MINUS_CONSTANT_COLOR$static;

  @JsName(r"ONE_MINUS_CONSTANT_COLOR")
  external static set ONE_MINUS_CONSTANT_COLOR$static(num value);

  /** @type {number} */
  @JsName(r"UNPACK_FLIP_Y_WEBGL")
  external static num get UNPACK_FLIP_Y_WEBGL$static;

  @JsName(r"UNPACK_FLIP_Y_WEBGL")
  external static set UNPACK_FLIP_Y_WEBGL$static(num value);

  /** @type {number} */
  @JsName(r"FRAMEBUFFER")
  external static num get FRAMEBUFFER$static;

  @JsName(r"FRAMEBUFFER")
  external static set FRAMEBUFFER$static(num value);

  /** @type {number} */
  @JsName(r"BLEND_SRC_RGB")
  external static num get BLEND_SRC_RGB$static;

  @JsName(r"BLEND_SRC_RGB")
  external static set BLEND_SRC_RGB$static(num value);

  /** @type {number} */
  @JsName(r"NEAREST_MIPMAP_LINEAR")
  external static num get NEAREST_MIPMAP_LINEAR$static;

  @JsName(r"NEAREST_MIPMAP_LINEAR")
  external static set NEAREST_MIPMAP_LINEAR$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE")
  external static num get TEXTURE$static;

  @JsName(r"TEXTURE")
  external static set TEXTURE$static(num value);

  /** @type {number} */
  @JsName(r"POINTS")
  external static num get POINTS$static;

  @JsName(r"POINTS")
  external static set POINTS$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_WRITEMASK")
  external static num get STENCIL_WRITEMASK$static;

  @JsName(r"STENCIL_WRITEMASK")
  external static set STENCIL_WRITEMASK$static(num value);

  /** @type {number} */
  @JsName(r"LUMINANCE_ALPHA")
  external static num get LUMINANCE_ALPHA$static;

  @JsName(r"LUMINANCE_ALPHA")
  external static set LUMINANCE_ALPHA$static(num value);

  /** @type {number} */
  @JsName(r"FUNC_SUBTRACT")
  external static num get FUNC_SUBTRACT$static;

  @JsName(r"FUNC_SUBTRACT")
  external static set FUNC_SUBTRACT$static(num value);

  /** @type {number} */
  @JsName(r"FUNC_ADD")
  external static num get FUNC_ADD$static;

  @JsName(r"FUNC_ADD")
  external static set FUNC_ADD$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_INDEX")
  external static num get STENCIL_INDEX$static;

  @JsName(r"STENCIL_INDEX")
  external static set STENCIL_INDEX$static(num value);

  /** @type {number} */
  @JsName(r"COLOR_CLEAR_VALUE")
  external static num get COLOR_CLEAR_VALUE$static;

  @JsName(r"COLOR_CLEAR_VALUE")
  external static set COLOR_CLEAR_VALUE$static(num value);

  /** @type {number} */
  @JsName(r"POLYGON_OFFSET_FILL")
  external static num get POLYGON_OFFSET_FILL$static;

  @JsName(r"POLYGON_OFFSET_FILL")
  external static set POLYGON_OFFSET_FILL$static(num value);

  /** @type {number} */
  @JsName(r"RENDERBUFFER_BLUE_SIZE")
  external static num get RENDERBUFFER_BLUE_SIZE$static;

  @JsName(r"RENDERBUFFER_BLUE_SIZE")
  external static set RENDERBUFFER_BLUE_SIZE$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_BACK_FAIL")
  external static num get STENCIL_BACK_FAIL$static;

  @JsName(r"STENCIL_BACK_FAIL")
  external static set STENCIL_BACK_FAIL$static(num value);

  /** @type {number} */
  @JsName(r"HIGH_INT")
  external static num get HIGH_INT$static;

  @JsName(r"HIGH_INT")
  external static set HIGH_INT$static(num value);

  /** @type {number} */
  @JsName(r"SRC_COLOR")
  external static num get SRC_COLOR$static;

  @JsName(r"SRC_COLOR")
  external static set SRC_COLOR$static(num value);

  /** @type {number} */
  @JsName(r"VALIDATE_STATUS")
  external static num get VALIDATE_STATUS$static;

  @JsName(r"VALIDATE_STATUS")
  external static set VALIDATE_STATUS$static(num value);

  /** @type {number} */
  @JsName(r"EQUAL")
  external static num get EQUAL$static;

  @JsName(r"EQUAL")
  external static set EQUAL$static(num value);

  /** @type {number} */
  @JsName(r"RENDERBUFFER_DEPTH_SIZE")
  external static num get RENDERBUFFER_DEPTH_SIZE$static;

  @JsName(r"RENDERBUFFER_DEPTH_SIZE")
  external static set RENDERBUFFER_DEPTH_SIZE$static(num value);

  /** @type {number} */
  @JsName(r"VERTEX_ATTRIB_ARRAY_ENABLED")
  external static num get VERTEX_ATTRIB_ARRAY_ENABLED$static;

  @JsName(r"VERTEX_ATTRIB_ARRAY_ENABLED")
  external static set VERTEX_ATTRIB_ARRAY_ENABLED$static(num value);

  /** @type {number} */
  @JsName(r"SHADING_LANGUAGE_VERSION")
  external static num get SHADING_LANGUAGE_VERSION$static;

  @JsName(r"SHADING_LANGUAGE_VERSION")
  external static set SHADING_LANGUAGE_VERSION$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_COMPONENT")
  external static num get DEPTH_COMPONENT$static;

  @JsName(r"DEPTH_COMPONENT")
  external static set DEPTH_COMPONENT$static(num value);

  /** @type {number} */
  @JsName(r"DEPTH_TEST")
  external static num get DEPTH_TEST$static;

  @JsName(r"DEPTH_TEST")
  external static set DEPTH_TEST$static(num value);

  /** @type {number} */
  @JsName(r"MAX_FRAGMENT_UNIFORM_VECTORS")
  external static num get MAX_FRAGMENT_UNIFORM_VECTORS$static;

  @JsName(r"MAX_FRAGMENT_UNIFORM_VECTORS")
  external static set MAX_FRAGMENT_UNIFORM_VECTORS$static(num value);

  /** @type {number} */
  @JsName(r"BYTE")
  external static num get BYTE$static;

  @JsName(r"BYTE")
  external static set BYTE$static(num value);

  /** @type {number} */
  @JsName(r"NEAREST_MIPMAP_NEAREST")
  external static num get NEAREST_MIPMAP_NEAREST$static;

  @JsName(r"NEAREST_MIPMAP_NEAREST")
  external static set NEAREST_MIPMAP_NEAREST$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_BACK_PASS_DEPTH_FAIL")
  external static num get STENCIL_BACK_PASS_DEPTH_FAIL$static;

  @JsName(r"STENCIL_BACK_PASS_DEPTH_FAIL")
  external static set STENCIL_BACK_PASS_DEPTH_FAIL$static(num value);

  /** @type {number} */
  @JsName(r"FRAMEBUFFER_INCOMPLETE_DIMENSIONS")
  external static num get FRAMEBUFFER_INCOMPLETE_DIMENSIONS$static;

  @JsName(r"FRAMEBUFFER_INCOMPLETE_DIMENSIONS")
  external static set FRAMEBUFFER_INCOMPLETE_DIMENSIONS$static(num value);

  /** @type {number} */
  @JsName(r"DYNAMIC_DRAW")
  external static num get DYNAMIC_DRAW$static;

  @JsName(r"DYNAMIC_DRAW")
  external static set DYNAMIC_DRAW$static(num value);

  /** @type {number} */
  @JsName(r"MIRRORED_REPEAT")
  external static num get MIRRORED_REPEAT$static;

  @JsName(r"MIRRORED_REPEAT")
  external static set MIRRORED_REPEAT$static(num value);

  /** @type {number} */
  @JsName(r"SCISSOR_TEST")
  external static num get SCISSOR_TEST$static;

  @JsName(r"SCISSOR_TEST")
  external static set SCISSOR_TEST$static(num value);

  /** @type {number} */
  @JsName(r"COLOR_BUFFER_BIT")
  external static num get COLOR_BUFFER_BIT$static;

  @JsName(r"COLOR_BUFFER_BIT")
  external static set COLOR_BUFFER_BIT$static(num value);

  /** @type {number} */
  @JsName(r"VERTEX_ATTRIB_ARRAY_STRIDE")
  external static num get VERTEX_ATTRIB_ARRAY_STRIDE$static;

  @JsName(r"VERTEX_ATTRIB_ARRAY_STRIDE")
  external static set VERTEX_ATTRIB_ARRAY_STRIDE$static(num value);

  /** @type {number} */
  @JsName(r"LUMINANCE")
  external static num get LUMINANCE$static;

  @JsName(r"LUMINANCE")
  external static set LUMINANCE$static(num value);

  /** @type {number} */
  @JsName(r"ONE_MINUS_SRC_ALPHA")
  external static num get ONE_MINUS_SRC_ALPHA$static;

  @JsName(r"ONE_MINUS_SRC_ALPHA")
  external static set ONE_MINUS_SRC_ALPHA$static(num value);

  /** @type {number} */
  @JsName(r"STATIC_DRAW")
  external static num get STATIC_DRAW$static;

  @JsName(r"STATIC_DRAW")
  external static set STATIC_DRAW$static(num value);

  /** @type {number} */
  @JsName(r"ONE_MINUS_SRC_COLOR")
  external static num get ONE_MINUS_SRC_COLOR$static;

  @JsName(r"ONE_MINUS_SRC_COLOR")
  external static set ONE_MINUS_SRC_COLOR$static(num value);

  /** @type {number} */
  @JsName(r"CCW")
  external static num get CCW$static;

  @JsName(r"CCW")
  external static set CCW$static(num value);

  /** @type {number} */
  @JsName(r"RENDERER")
  external static num get RENDERER$static;

  @JsName(r"RENDERER")
  external static set RENDERER$static(num value);

  /** @type {number} */
  @JsName(r"CURRENT_VERTEX_ATTRIB")
  external static num get CURRENT_VERTEX_ATTRIB$static;

  @JsName(r"CURRENT_VERTEX_ATTRIB")
  external static set CURRENT_VERTEX_ATTRIB$static(num value);

  /** @type {number} */
  @JsName(r"HIGH_FLOAT")
  external static num get HIGH_FLOAT$static;

  @JsName(r"HIGH_FLOAT")
  external static set HIGH_FLOAT$static(num value);

  /** @type {number} */
  @JsName(r"LINE_LOOP")
  external static num get LINE_LOOP$static;

  @JsName(r"LINE_LOOP")
  external static set LINE_LOOP$static(num value);

  /** @type {number} */
  @JsName(r"LINE_WIDTH")
  external static num get LINE_WIDTH$static;

  @JsName(r"LINE_WIDTH")
  external static set LINE_WIDTH$static(num value);

  /** @type {number} */
  @JsName(r"SRC_ALPHA_SATURATE")
  external static num get SRC_ALPHA_SATURATE$static;

  @JsName(r"SRC_ALPHA_SATURATE")
  external static set SRC_ALPHA_SATURATE$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_REF")
  external static num get STENCIL_REF$static;

  @JsName(r"STENCIL_REF")
  external static set STENCIL_REF$static(num value);

  /** @type {number} */
  @JsName(r"FUNC_REVERSE_SUBTRACT")
  external static num get FUNC_REVERSE_SUBTRACT$static;

  @JsName(r"FUNC_REVERSE_SUBTRACT")
  external static set FUNC_REVERSE_SUBTRACT$static(num value);

  /** @type {number} */
  @JsName(r"CULL_FACE")
  external static num get CULL_FACE$static;

  @JsName(r"CULL_FACE")
  external static set CULL_FACE$static(num value);

  /** @type {number} */
  @JsName(r"STENCIL_BACK_FUNC")
  external static num get STENCIL_BACK_FUNC$static;

  @JsName(r"STENCIL_BACK_FUNC")
  external static set STENCIL_BACK_FUNC$static(num value);

  /** @type {number} */
  @JsName(r"KEEP")
  external static num get KEEP$static;

  @JsName(r"KEEP")
  external static set KEEP$static(num value);

  /** @type {number} */
  @JsName(r"CONSTANT_COLOR")
  external static num get CONSTANT_COLOR$static;

  @JsName(r"CONSTANT_COLOR")
  external static set CONSTANT_COLOR$static(num value);

  /** @type {number} */
  @JsName(r"DECR")
  external static num get DECR$static;

  @JsName(r"DECR")
  external static set DECR$static(num value);

  /** @type {number} */
  @JsName(r"FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE")
  external static num get FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE$static;

  @JsName(r"FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE")
  external static set FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE$static(
      num value);

  /** @type {number} */
  @JsName(r"BLEND_COLOR")
  external static num get BLEND_COLOR$static;

  @JsName(r"BLEND_COLOR")
  external static set BLEND_COLOR$static(num value);

  /** @type {number} */
  @JsName(r"UNSIGNED_INT")
  external static num get UNSIGNED_INT$static;

  @JsName(r"UNSIGNED_INT")
  external static set UNSIGNED_INT$static(num value);

  /** @type {number} */
  @JsName(r"TEXTURE_2D")
  external static num get TEXTURE_2D$static;

  @JsName(r"TEXTURE_2D")
  external static set TEXTURE_2D$static(num value);

  /** @type {number} */
  @JsName(r"FRAGMENT_SHADER")
  external static num get FRAGMENT_SHADER$static;

  @JsName(r"FRAGMENT_SHADER")
  external static set FRAGMENT_SHADER$static(num value);

  /** @type {number} */
  @JsName(r"BLEND_DST_RGB")
  external static num get BLEND_DST_RGB$static;

  @JsName(r"BLEND_DST_RGB")
  external static set BLEND_DST_RGB$static(num value);

  /** @type {number} */
  @JsName(r"NEAREST")
  external static num get NEAREST$static;

  @JsName(r"NEAREST")
  external static set NEAREST$static(num value);

  /** @type {number} */
  num DEPTH_BUFFER_BIT;

  /** @type {number} */
  num STENCIL_BUFFER_BIT;

  /** @type {number} */
  num COLOR_BUFFER_BIT;

  /** @type {number} */
  num POINTS;

  /** @type {number} */
  num LINES;

  /** @type {number} */
  num LINE_LOOP;

  /** @type {number} */
  num LINE_STRIP;

  /** @type {number} */
  num TRIANGLES;

  /** @type {number} */
  num TRIANGLE_STRIP;

  /** @type {number} */
  num TRIANGLE_FAN;

  /** @type {number} */
  num ZERO;

  /** @type {number} */
  num ONE;

  /** @type {number} */
  num SRC_COLOR;

  /** @type {number} */
  num ONE_MINUS_SRC_COLOR;

  /** @type {number} */
  num SRC_ALPHA;

  /** @type {number} */
  num ONE_MINUS_SRC_ALPHA;

  /** @type {number} */
  num DST_ALPHA;

  /** @type {number} */
  num ONE_MINUS_DST_ALPHA;

  /** @type {number} */
  num DST_COLOR;

  /** @type {number} */
  num ONE_MINUS_DST_COLOR;

  /** @type {number} */
  num SRC_ALPHA_SATURATE;

  /** @type {number} */
  num FUNC_ADD;

  /** @type {number} */
  num BLEND_EQUATION;

  /** @type {number} */
  num BLEND_EQUATION_RGB;

  /** @type {number} */
  num BLEND_EQUATION_ALPHA;

  /** @type {number} */
  num FUNC_SUBTRACT;

  /** @type {number} */
  num FUNC_REVERSE_SUBTRACT;

  /** @type {number} */
  num BLEND_DST_RGB;

  /** @type {number} */
  num BLEND_SRC_RGB;

  /** @type {number} */
  num BLEND_DST_ALPHA;

  /** @type {number} */
  num BLEND_SRC_ALPHA;

  /** @type {number} */
  num CONSTANT_COLOR;

  /** @type {number} */
  num ONE_MINUS_CONSTANT_COLOR;

  /** @type {number} */
  num CONSTANT_ALPHA;

  /** @type {number} */
  num ONE_MINUS_CONSTANT_ALPHA;

  /** @type {number} */
  num BLEND_COLOR;

  /** @type {number} */
  num ARRAY_BUFFER;

  /** @type {number} */
  num ELEMENT_ARRAY_BUFFER;

  /** @type {number} */
  num ARRAY_BUFFER_BINDING;

  /** @type {number} */
  num ELEMENT_ARRAY_BUFFER_BINDING;

  /** @type {number} */
  num STREAM_DRAW;

  /** @type {number} */
  num STATIC_DRAW;

  /** @type {number} */
  num DYNAMIC_DRAW;

  /** @type {number} */
  num BUFFER_SIZE;

  /** @type {number} */
  num BUFFER_USAGE;

  /** @type {number} */
  num CURRENT_VERTEX_ATTRIB;

  /** @type {number} */
  num FRONT;

  /** @type {number} */
  num BACK;

  /** @type {number} */
  num FRONT_AND_BACK;

  /** @type {number} */
  num CULL_FACE;

  /** @type {number} */
  num BLEND;

  /** @type {number} */
  num DITHER;

  /** @type {number} */
  num STENCIL_TEST;

  /** @type {number} */
  num DEPTH_TEST;

  /** @type {number} */
  num SCISSOR_TEST;

  /** @type {number} */
  num POLYGON_OFFSET_FILL;

  /** @type {number} */
  num SAMPLE_ALPHA_TO_COVERAGE;

  /** @type {number} */
  num SAMPLE_COVERAGE;

  /** @type {number} */
  num NO_ERROR;

  /** @type {number} */
  num INVALID_ENUM;

  /** @type {number} */
  num INVALID_VALUE;

  /** @type {number} */
  num INVALID_OPERATION;

  /** @type {number} */
  num OUT_OF_MEMORY;

  /** @type {number} */
  num CW;

  /** @type {number} */
  num CCW;

  /** @type {number} */
  num LINE_WIDTH;

  /** @type {number} */
  num ALIASED_POINT_SIZE_RANGE;

  /** @type {number} */
  num ALIASED_LINE_WIDTH_RANGE;

  /** @type {number} */
  num CULL_FACE_MODE;

  /** @type {number} */
  num FRONT_FACE;

  /** @type {number} */
  num DEPTH_RANGE;

  /** @type {number} */
  num DEPTH_WRITEMASK;

  /** @type {number} */
  num DEPTH_CLEAR_VALUE;

  /** @type {number} */
  num DEPTH_FUNC;

  /** @type {number} */
  num STENCIL_CLEAR_VALUE;

  /** @type {number} */
  num STENCIL_FUNC;

  /** @type {number} */
  num STENCIL_FAIL;

  /** @type {number} */
  num STENCIL_PASS_DEPTH_FAIL;

  /** @type {number} */
  num STENCIL_PASS_DEPTH_PASS;

  /** @type {number} */
  num STENCIL_REF;

  /** @type {number} */
  num STENCIL_VALUE_MASK;

  /** @type {number} */
  num STENCIL_WRITEMASK;

  /** @type {number} */
  num STENCIL_BACK_FUNC;

  /** @type {number} */
  num STENCIL_BACK_FAIL;

  /** @type {number} */
  num STENCIL_BACK_PASS_DEPTH_FAIL;

  /** @type {number} */
  num STENCIL_BACK_PASS_DEPTH_PASS;

  /** @type {number} */
  num STENCIL_BACK_REF;

  /** @type {number} */
  num STENCIL_BACK_VALUE_MASK;

  /** @type {number} */
  num STENCIL_BACK_WRITEMASK;

  /** @type {number} */
  num VIEWPORT;

  /** @type {number} */
  num SCISSOR_BOX;

  /** @type {number} */
  num COLOR_CLEAR_VALUE;

  /** @type {number} */
  num COLOR_WRITEMASK;

  /** @type {number} */
  num UNPACK_ALIGNMENT;

  /** @type {number} */
  num PACK_ALIGNMENT;

  /** @type {number} */
  num MAX_TEXTURE_SIZE;

  /** @type {number} */
  num MAX_VIEWPORT_DIMS;

  /** @type {number} */
  num SUBPIXEL_BITS;

  /** @type {number} */
  num RED_BITS;

  /** @type {number} */
  num GREEN_BITS;

  /** @type {number} */
  num BLUE_BITS;

  /** @type {number} */
  num ALPHA_BITS;

  /** @type {number} */
  num DEPTH_BITS;

  /** @type {number} */
  num STENCIL_BITS;

  /** @type {number} */
  num POLYGON_OFFSET_UNITS;

  /** @type {number} */
  num POLYGON_OFFSET_FACTOR;

  /** @type {number} */
  num TEXTURE_BINDING_2D;

  /** @type {number} */
  num SAMPLE_BUFFERS;

  /** @type {number} */
  num SAMPLES;

  /** @type {number} */
  num SAMPLE_COVERAGE_VALUE;

  /** @type {number} */
  num SAMPLE_COVERAGE_INVERT;

  /** @type {number} */
  num COMPRESSED_TEXTURE_FORMATS;

  /** @type {number} */
  num DONT_CARE;

  /** @type {number} */
  num FASTEST;

  /** @type {number} */
  num NICEST;

  /** @type {number} */
  num GENERATE_MIPMAP_HINT;

  /** @type {number} */
  num BYTE;

  /** @type {number} */
  num UNSIGNED_BYTE;

  /** @type {number} */
  num SHORT;

  /** @type {number} */
  num UNSIGNED_SHORT;

  /** @type {number} */
  num INT;

  /** @type {number} */
  num UNSIGNED_INT;

  /** @type {number} */
  num FLOAT;

  /** @type {number} */
  num DEPTH_COMPONENT;

  /** @type {number} */
  num ALPHA;

  /** @type {number} */
  num RGB;

  /** @type {number} */
  num RGBA;

  /** @type {number} */
  num LUMINANCE;

  /** @type {number} */
  num LUMINANCE_ALPHA;

  /** @type {number} */
  num UNSIGNED_SHORT_4_4_4_4;

  /** @type {number} */
  num UNSIGNED_SHORT_5_5_5_1;

  /** @type {number} */
  num UNSIGNED_SHORT_5_6_5;

  /** @type {number} */
  num FRAGMENT_SHADER;

  /** @type {number} */
  num VERTEX_SHADER;

  /** @type {number} */
  num MAX_VERTEX_ATTRIBS;

  /** @type {number} */
  num MAX_VERTEX_UNIFORM_VECTORS;

  /** @type {number} */
  num MAX_VARYING_VECTORS;

  /** @type {number} */
  num MAX_COMBINED_TEXTURE_IMAGE_UNITS;

  /** @type {number} */
  num MAX_VERTEX_TEXTURE_IMAGE_UNITS;

  /** @type {number} */
  num MAX_TEXTURE_IMAGE_UNITS;

  /** @type {number} */
  num MAX_FRAGMENT_UNIFORM_VECTORS;

  /** @type {number} */
  num SHADER_TYPE;

  /** @type {number} */
  num DELETE_STATUS;

  /** @type {number} */
  num LINK_STATUS;

  /** @type {number} */
  num VALIDATE_STATUS;

  /** @type {number} */
  num ATTACHED_SHADERS;

  /** @type {number} */
  num ACTIVE_UNIFORMS;

  /** @type {number} */
  num ACTIVE_ATTRIBUTES;

  /** @type {number} */
  num SHADING_LANGUAGE_VERSION;

  /** @type {number} */
  num CURRENT_PROGRAM;

  /** @type {number} */
  num NEVER;

  /** @type {number} */
  num LESS;

  /** @type {number} */
  num EQUAL;

  /** @type {number} */
  num LEQUAL;

  /** @type {number} */
  num GREATER;

  /** @type {number} */
  num NOTEQUAL;

  /** @type {number} */
  num GEQUAL;

  /** @type {number} */
  num ALWAYS;

  /** @type {number} */
  num KEEP;

  /** @type {number} */
  num REPLACE;

  /** @type {number} */
  num INCR;

  /** @type {number} */
  num DECR;

  /** @type {number} */
  num INVERT;

  /** @type {number} */
  num INCR_WRAP;

  /** @type {number} */
  num DECR_WRAP;

  /** @type {number} */
  num VENDOR;

  /** @type {number} */
  num RENDERER;

  /** @type {number} */
  num VERSION;

  /** @type {number} */
  num NEAREST;

  /** @type {number} */
  num LINEAR;

  /** @type {number} */
  num NEAREST_MIPMAP_NEAREST;

  /** @type {number} */
  num LINEAR_MIPMAP_NEAREST;

  /** @type {number} */
  num NEAREST_MIPMAP_LINEAR;

  /** @type {number} */
  num LINEAR_MIPMAP_LINEAR;

  /** @type {number} */
  num TEXTURE_MAG_FILTER;

  /** @type {number} */
  num TEXTURE_MIN_FILTER;

  /** @type {number} */
  num TEXTURE_WRAP_S;

  /** @type {number} */
  num TEXTURE_WRAP_T;

  /** @type {number} */
  num TEXTURE_2D;

  /** @type {number} */
  num TEXTURE;

  /** @type {number} */
  num TEXTURE_CUBE_MAP;

  /** @type {number} */
  num TEXTURE_BINDING_CUBE_MAP;

  /** @type {number} */
  num TEXTURE_CUBE_MAP_POSITIVE_X;

  /** @type {number} */
  num TEXTURE_CUBE_MAP_NEGATIVE_X;

  /** @type {number} */
  num TEXTURE_CUBE_MAP_POSITIVE_Y;

  /** @type {number} */
  num TEXTURE_CUBE_MAP_NEGATIVE_Y;

  /** @type {number} */
  num TEXTURE_CUBE_MAP_POSITIVE_Z;

  /** @type {number} */
  num TEXTURE_CUBE_MAP_NEGATIVE_Z;

  /** @type {number} */
  num MAX_CUBE_MAP_TEXTURE_SIZE;

  /** @type {number} */
  num TEXTURE0;

  /** @type {number} */
  num TEXTURE1;

  /** @type {number} */
  num TEXTURE2;

  /** @type {number} */
  num TEXTURE3;

  /** @type {number} */
  num TEXTURE4;

  /** @type {number} */
  num TEXTURE5;

  /** @type {number} */
  num TEXTURE6;

  /** @type {number} */
  num TEXTURE7;

  /** @type {number} */
  num TEXTURE8;

  /** @type {number} */
  num TEXTURE9;

  /** @type {number} */
  num TEXTURE10;

  /** @type {number} */
  num TEXTURE11;

  /** @type {number} */
  num TEXTURE12;

  /** @type {number} */
  num TEXTURE13;

  /** @type {number} */
  num TEXTURE14;

  /** @type {number} */
  num TEXTURE15;

  /** @type {number} */
  num TEXTURE16;

  /** @type {number} */
  num TEXTURE17;

  /** @type {number} */
  num TEXTURE18;

  /** @type {number} */
  num TEXTURE19;

  /** @type {number} */
  num TEXTURE20;

  /** @type {number} */
  num TEXTURE21;

  /** @type {number} */
  num TEXTURE22;

  /** @type {number} */
  num TEXTURE23;

  /** @type {number} */
  num TEXTURE24;

  /** @type {number} */
  num TEXTURE25;

  /** @type {number} */
  num TEXTURE26;

  /** @type {number} */
  num TEXTURE27;

  /** @type {number} */
  num TEXTURE28;

  /** @type {number} */
  num TEXTURE29;

  /** @type {number} */
  num TEXTURE30;

  /** @type {number} */
  num TEXTURE31;

  /** @type {number} */
  num ACTIVE_TEXTURE;

  /** @type {number} */
  num REPEAT;

  /** @type {number} */
  num CLAMP_TO_EDGE;

  /** @type {number} */
  num MIRRORED_REPEAT;

  /** @type {number} */
  num FLOAT_VEC2;

  /** @type {number} */
  num FLOAT_VEC3;

  /** @type {number} */
  num FLOAT_VEC4;

  /** @type {number} */
  num INT_VEC2;

  /** @type {number} */
  num INT_VEC3;

  /** @type {number} */
  num INT_VEC4;

  /** @type {number} */
  num BOOL;

  /** @type {number} */
  num BOOL_VEC2;

  /** @type {number} */
  num BOOL_VEC3;

  /** @type {number} */
  num BOOL_VEC4;

  /** @type {number} */
  num FLOAT_MAT2;

  /** @type {number} */
  num FLOAT_MAT3;

  /** @type {number} */
  num FLOAT_MAT4;

  /** @type {number} */
  num SAMPLER_2D;

  /** @type {number} */
  num SAMPLER_CUBE;

  /** @type {number} */
  num VERTEX_ATTRIB_ARRAY_ENABLED;

  /** @type {number} */
  num VERTEX_ATTRIB_ARRAY_SIZE;

  /** @type {number} */
  num VERTEX_ATTRIB_ARRAY_STRIDE;

  /** @type {number} */
  num VERTEX_ATTRIB_ARRAY_TYPE;

  /** @type {number} */
  num VERTEX_ATTRIB_ARRAY_NORMALIZED;

  /** @type {number} */
  num VERTEX_ATTRIB_ARRAY_POINTER;

  /** @type {number} */
  num VERTEX_ATTRIB_ARRAY_BUFFER_BINDING;

  /** @type {number} */
  num COMPILE_STATUS;

  /** @type {number} */
  num LOW_FLOAT;

  /** @type {number} */
  num MEDIUM_FLOAT;

  /** @type {number} */
  num HIGH_FLOAT;

  /** @type {number} */
  num LOW_INT;

  /** @type {number} */
  num MEDIUM_INT;

  /** @type {number} */
  num HIGH_INT;

  /** @type {number} */
  num FRAMEBUFFER;

  /** @type {number} */
  num RENDERBUFFER;

  /** @type {number} */
  num RGBA4;

  /** @type {number} */
  num RGB5_A1;

  /** @type {number} */
  num RGB565;

  /** @type {number} */
  num DEPTH_COMPONENT16;

  /** @type {number} */
  num STENCIL_INDEX;

  /** @type {number} */
  num STENCIL_INDEX8;

  /** @type {number} */
  num DEPTH_STENCIL;

  /** @type {number} */
  num RENDERBUFFER_WIDTH;

  /** @type {number} */
  num RENDERBUFFER_HEIGHT;

  /** @type {number} */
  num RENDERBUFFER_INTERNAL_FORMAT;

  /** @type {number} */
  num RENDERBUFFER_RED_SIZE;

  /** @type {number} */
  num RENDERBUFFER_GREEN_SIZE;

  /** @type {number} */
  num RENDERBUFFER_BLUE_SIZE;

  /** @type {number} */
  num RENDERBUFFER_ALPHA_SIZE;

  /** @type {number} */
  num RENDERBUFFER_DEPTH_SIZE;

  /** @type {number} */
  num RENDERBUFFER_STENCIL_SIZE;

  /** @type {number} */
  num FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE;

  /** @type {number} */
  num FRAMEBUFFER_ATTACHMENT_OBJECT_NAME;

  /** @type {number} */
  num FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL;

  /** @type {number} */
  num FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE;

  /** @type {number} */
  num COLOR_ATTACHMENT0;

  /** @type {number} */
  num DEPTH_ATTACHMENT;

  /** @type {number} */
  num STENCIL_ATTACHMENT;

  /** @type {number} */
  num DEPTH_STENCIL_ATTACHMENT;

  /** @type {number} */
  num NONE;

  /** @type {number} */
  num FRAMEBUFFER_COMPLETE;

  /** @type {number} */
  num FRAMEBUFFER_INCOMPLETE_ATTACHMENT;

  /** @type {number} */
  num FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT;

  /** @type {number} */
  num FRAMEBUFFER_INCOMPLETE_DIMENSIONS;

  /** @type {number} */
  num FRAMEBUFFER_UNSUPPORTED;

  /** @type {number} */
  num FRAMEBUFFER_BINDING;

  /** @type {number} */
  num RENDERBUFFER_BINDING;

  /** @type {number} */
  num MAX_RENDERBUFFER_SIZE;

  /** @type {number} */
  num INVALID_FRAMEBUFFER_OPERATION;

  /** @type {number} */
  num UNPACK_FLIP_Y_WEBGL;

  /** @type {number} */
  num UNPACK_PREMULTIPLY_ALPHA_WEBGL;

  /** @type {number} */
  num CONTEXT_LOST_WEBGL;

  /** @type {number} */
  num UNPACK_COLORSPACE_CONVERSION_WEBGL;

  /** @type {number} */
  num BROWSER_DEFAULT_WEBGL;

  /**
   * @type {!HTMLCanvasElement}
   */
  html5.HTMLCanvasElement canvas;

  /**
   * @type {number}
   */
  num drawingBufferWidth;

  /**
   * @type {number}
   */
  num drawingBufferHeight;

  /**
   * @return {!WebGLContextAttributes}
   * @nosideeffects
   */
  WebGLContextAttributes getContextAttributes();

  /**
   * @return {boolean}
   * @nosideeffects
   */
  bool isContextLost();

  /**
   * @return {!Array.<string>}
   * @nosideeffects
   */
  List<String> getSupportedExtensions();

  /**
   * Note that this has side effects by enabling the extension even if the
   * result is not used.
   * @param {string} name
   * @return {Object}
   */
  Object getExtension(String name);

  /**
   * @param {number} texture
   */
  activeTexture(num texture);

  /**
   * @param {WebGLProgram} program
   * @param {WebGLShader} shader
   */
  attachShader(WebGLProgram program, WebGLShader shader);

  /**
   * @param {WebGLProgram} program
   * @param {number} index
   * @param {string} name
   */
  bindAttribLocation(WebGLProgram program, num index, String name);

  /**
   * @param {number} target
   * @param {WebGLBuffer} buffer
   */
  bindBuffer(num target, WebGLBuffer buffer);

  /**
   * @param {number} target
   * @param {WebGLFramebuffer} buffer
   */
  bindFramebuffer(num target, WebGLFramebuffer buffer);

  /**
   * @param {number} target
   * @param {WebGLRenderbuffer} buffer
   */
  bindRenderbuffer(num target, WebGLRenderbuffer buffer);

  /**
   * @param {number} target
   * @param {WebGLTexture} texture
   */
  bindTexture(num target, WebGLTexture texture);

  /**
   * @param {number} red
   * @param {number} green
   * @param {number} blue
   * @param {number} alpha
   */
  blendColor(num red, num blue, num green, num alpha);

  /**
   * @param {number} mode
   */
  blendEquation(num mode);

  /**
   * @param {number} modeRGB
   * @param {number} modeAlpha
   */
  blendEquationSeparate(num modeRGB, num modeAlpha);

  /**
   * @param {number} sfactor
   * @param {number} dfactor
   */
  blendFunc(num sfactor, num dfactor);

  /**
   * @param {number} srcRGB
   * @param {number} dstRGB
   * @param {number} srcAlpha
   * @param {number} dstAlpha
   */
  blendFuncSeparate(num srcRGB, num dstRGB, num srcAlpha, num dstAlpha);

  /**
   * @param {number} target
   * @param {ArrayBufferView|ArrayBuffer|number} data
   * @param {number} usage
   */
  bufferData(num target, data /*es6.ArrayBufferView|null|es6.ArrayBuffer|num*/,
      num usage);

  /**
   * @param {number} target
   * @param {number} offset
   * @param {ArrayBufferView|ArrayBuffer} data
   */
  bufferSubData(num target, num offset,
      data /*es6.ArrayBufferView|null|es6.ArrayBuffer*/);

  /**
   * @param {number} target
   * @return {number}
   */
  num checkFramebufferStatus(num target);

  /**
   * @param {number} mask
   */
  clear(num mask);

  /**
   * @param {number} red
   * @param {number} green
   * @param {number} blue
   * @param {number} alpha
   */
  clearColor(num red, num green, num blue, num alpha);

  /**
   * @param {number} depth
   */
  clearDepth(num depth);

  /**
   * @param {number} s
   */
  clearStencil(num s);

  /**
   * @param {boolean} red
   * @param {boolean} green
   * @param {boolean} blue
   * @param {boolean} alpha
   */
  colorMask(bool red, bool green, bool blue, bool alpha);

  /**
   * @param {WebGLShader} shader
   */
  compileShader(WebGLShader shader);

  /**
   * @param {number} target
   * @param {number} level
   * @param {number} internalformat
   * @param {number} width
   * @param {number} height
   * @param {number} border
   * @param {ArrayBufferView} data
   */
  compressedTexImage2D(num target, num level, num internalformat, num width,
      num height, num border, es6.ArrayBufferView data);

  /**
   * @param {number} target
   * @param {number} level
   * @param {number} xoffset
   * @param {number} yoffset
   * @param {number} width
   * @param {number} height
   * @param {number} format
   * @param {ArrayBufferView} data
   */
  compressedTexSubImage2D(num target, num level, num xoffset, num yoffset,
      num width, num height, num format, es6.ArrayBufferView data);

  /**
   * @param {number} target
   * @param {number} level
   * @param {number} format
   * @param {number} x
   * @param {number} y
   * @param {number} width
   * @param {number} height
   * @param {number} border
   */
  copyTexImage2D(num target, num level, num format, num x, num y, num width,
      num height, num border);

  /**
   * @param {number} target
   * @param {number} level
   * @param {number} xoffset
   * @param {number} yoffset
   * @param {number} x
   * @param {number} y
   * @param {number} width
   * @param {number} height
   */
  copyTexSubImage2D(num target, num level, num xoffset, num yoffset, num x,
      num y, num width, num height);

  /**
   * @return {!WebGLBuffer}
   * @nosideeffects
   */
  WebGLBuffer createBuffer();

  /**
   * @return {!WebGLFramebuffer}
   * @nosideeffects
   */
  WebGLFramebuffer createFramebuffer();

  /**
   * @return {!WebGLProgram}
   * @nosideeffects
   */
  WebGLProgram createProgram();

  /**
   * @return {!WebGLRenderbuffer}
   * @nosideeffects
   */
  WebGLRenderbuffer createRenderbuffer();

  /**
   * @param {number} type
   * @return {!WebGLShader}
   * @nosideeffects
   */
  WebGLShader createShader(num type);

  /**
   * @return {!WebGLTexture}
   * @nosideeffects
   */
  WebGLTexture createTexture();

  /**
   * @param {number} mode
   */
  cullFace(num mode);

  /**
   * @param {WebGLBuffer} buffer
   */
  deleteBuffer(WebGLBuffer buffer);

  /**
   * @param {WebGLFramebuffer} buffer
   */
  deleteFramebuffer(WebGLFramebuffer buffer);

  /**
   * @param {WebGLProgram} program
   */
  deleteProgram(WebGLProgram program);

  /**
   * @param {WebGLRenderbuffer} buffer
   */
  deleteRenderbuffer(WebGLRenderbuffer buffer);

  /**
   * @param {WebGLShader} shader
   */
  deleteShader(WebGLShader shader);

  /**
   * @param {WebGLTexture} texture
   */
  deleteTexture(WebGLTexture texture);

  /**
   * @param {number} func
   */
  depthFunc(num func);

  /**
   * @param {boolean} flag
   */
  depthMask(bool flag);

  /**
   * @param {number} nearVal
   * @param {number} farVal
   */
  depthRange(num nearVal, num farVal);

  /**
   * @param {WebGLProgram} program
   * @param {WebGLShader} shader
   */
  detachShader(WebGLProgram program, WebGLShader shader);

  /**
   * @param {number} flags
   */
  disable(num flags);

  /**
   * @param {number} index
   */
  disableVertexAttribArray(num index);

  /**
   * @param {number} mode
   * @param {number} first
   * @param {number} count
   */
  drawArrays(num mode, num first, num count);

  /**
   * @param {number} mode
   * @param {number} count
   * @param {number} type
   * @param {number} offset
   */
  drawElements(num mode, num count, num type, num offset);

  /**
   * @param {number} cap
   */
  enable(num cap);

  /**
   * @param {number} index
   */
  enableVertexAttribArray(num index);

  finish();

  flush();

  /**
   * @param {number} target
   * @param {number} attachment
   * @param {number} renderbuffertarget
   * @param {WebGLRenderbuffer} renderbuffer
   */
  framebufferRenderbuffer(num target, num attachment, num renderbuffertarget,
      WebGLRenderbuffer renderbuffer);

  /**
   * @param {number} target
   * @param {number} attachment
   * @param {number} textarget
   * @param {WebGLTexture} texture
   * @param {number} level
   */
  framebufferTexture2D(num target, num attachment, num textarget,
      WebGLTexture texture, num level);

  /**
   * @param {number} mode
   */
  frontFace(num mode);

  /**
   * @param {number} target
   */
  generateMipmap(num target);

  /**
   * @param {WebGLProgram} program
   * @param {number} index
   * @return {WebGLActiveInfo}
   * @nosideeffects
   */
  WebGLActiveInfo getActiveAttrib(WebGLProgram program, num index);

  /**
   * @param {WebGLProgram} program
   * @param {number} index
   * @return {WebGLActiveInfo}
   * @nosideeffects
   */
  WebGLActiveInfo getActiveUniform(WebGLProgram program, num index);

  /**
   * @param {WebGLProgram} program
   * @return {!Array.<WebGLShader>}
   * @nosideeffects
   */
  List<WebGLShader> getAttachedShaders(WebGLProgram program);

  /**
   * @param {WebGLProgram} program
   * @param {string} name
   * @return {number}
   * @nosideeffects
   */
  num getAttribLocation(WebGLProgram program, String name);

  /**
   * @param {number} target
   * @param {number} pname
   * @return {*}
   * @nosideeffects
   */
  getBufferParameter(num target, num pname);

  /**
   * @param {number} pname
   * @return {*}
   * @nosideeffects
   */
  getParameter(num pname);

  /**
   * @return {number}
   * @nosideeffects
   */
  num getError();

  /**
   * @param {number} target
   * @param {number} attachment
   * @param {number} pname
   * @return {*}
   * @nosideeffects
   */
  getFramebufferAttachmentParameter(num target, num attachment, num pname);

  /**
   * @param {WebGLProgram} program
   * @param {number} pname
   * @return {*}
   * @nosideeffects
   */
  getProgramParameter(WebGLProgram program, num pname);

  /**
   * @param {WebGLProgram} program
   * @return {string}
   * @nosideeffects
   */
  String getProgramInfoLog(WebGLProgram program);

  /**
   * @param {number} target
   * @param {number} pname
   * @return {*}
   * @nosideeffects
   */
  getRenderbufferParameter(num target, num pname);

  /**
   * @param {WebGLShader} shader
   * @param {number} pname
   * @return {*}
   * @nosideeffects
   */
  getShaderParameter(WebGLShader shader, num pname);

  /**
   * @param {number} shadertype
   * @param {number} precisiontype
   * @return {WebGLShaderPrecisionFormat}
   * @nosideeffects
   */
  WebGLShaderPrecisionFormat getShaderPrecisionFormat(
      num shadertype, num precisiontype);

  /**
   * @param {WebGLShader} shader
   * @return {string}
   * @nosideeffects
   */
  String getShaderInfoLog(WebGLShader shader);

  /**
   * @param {WebGLShader} shader
   * @return {string}
   * @nosideeffects
   */
  String getShaderSource(WebGLShader shader);

  /**
   * @param {number} target
   * @param {number} pname
   * @return {*}
   * @nosideeffects
   */
  getTexParameter(num target, num pname);

  /**
   * @param {WebGLProgram} program
   * @param {WebGLUniformLocation} location
   * @return {*}
   * @nosideeffects
   */
  getUniform(WebGLProgram program, WebGLUniformLocation location);

  /**
   * @param {WebGLProgram} program
   * @param {string} name
   * @return {WebGLUniformLocation}
   * @nosideeffects
   */
  WebGLUniformLocation getUniformLocation(WebGLProgram program, String name);

  /**
   * @param {number} index
   * @param {number} pname
   * @return {*}
   * @nosideeffects
   */
  getVertexAttrib(num index, num pname);

  /**
   * @param {number} index
   * @param {number} pname
   * @return {number}
   * @nosideeffects
   */
  num getVertexAttribOffset(num index, num pname);

  /**
   * @param {number} target
   * @param {number} mode
   */
  hint(num target, num mode);

  /**
   * @param {WebGLObject} buffer
   * @return {boolean}
   * @nosideeffects
   */
  bool isBuffer(WebGLObject buffer);

  /**
   * @param {number} cap
   * @return {boolean}
   * @nosideeffects
   */
  bool isEnabled(num cap);

  /**
   * @param {WebGLObject} framebuffer
   * @return {boolean}
   * @nosideeffects
   */
  bool isFramebuffer(WebGLObject framebuffer);

  /**
   * @param {WebGLObject} program
   * @return {boolean}
   * @nosideeffects
   */
  bool isProgram(WebGLObject program);

  /**
   * @param {WebGLObject} renderbuffer
   * @return {boolean}
   * @nosideeffects
   */
  bool isRenderbuffer(WebGLObject renderbuffer);

  /**
   * @param {WebGLObject} shader
   * @return {boolean}
   * @nosideeffects
   */
  bool isShader(WebGLObject shader);

  /**
   * @param {WebGLObject} texture
   * @return {boolean}
   * @nosideeffects
   */
  bool isTexture(WebGLObject texture);

  /**
   * @param {number} width
   */
  lineWidth(num width);

  /**
   * @param {WebGLProgram} program
   */
  linkProgram(WebGLProgram program);

  /**
   * @param {number} pname
   * @param {number} param
   */
  pixelStorei(num pname, num param);

  /**
   * @param {number} factor
   * @param {number} units
   */
  polygonOffset(num factor, num units);

  /**
   * @param {number} x
   * @param {number} y
   * @param {number} width
   * @param {number} height
   * @param {number} format
   * @param {number} type
   * @param {ArrayBufferView} pixels
   */
  readPixels(num x, num y, num width, num height, num format, num type,
      es6.ArrayBufferView pixels);

  /**
   * @param {number} target
   * @param {number} internalformat
   * @param {number} width
   * @param {number} height
   */
  renderbufferStorage(num target, num internalformat, num width, num height);

  /**
   * @param {number} coverage
   * @param {boolean} invert
   */
  sampleCoverage(num coverage, bool invert);

  /**
   * @param {number} x
   * @param {number} y
   * @param {number} width
   * @param {number} height
   */
  scissor(num x, num y, num width, num height);

  /**
   * @param {WebGLShader} shader
   * @param {string} source
   */
  shaderSource(WebGLShader shader, String source);

  /**
   * @param {number} func
   * @param {number} ref
   * @param {number} mask
   */
  stencilFunc(num func, num ref, num mask);

  /**
   * @param {number} face
   * @param {number} func
   * @param {number} ref
   * @param {number} mask
   */
  stencilFuncSeparate(num face, num func, num ref, num mask);

  /**
   * @param {number} mask
   */
  stencilMask(num mask);

  /**
   * @param {number} face
   * @param {number} mask
   */
  stencilMaskSeparate(num face, num mask);

  /**
   * @param {number} fail
   * @param {number} zfail
   * @param {number} zpass
   */
  stencilOp(num fail, num zfail, num zpass);

  /**
   * @param {number} face
   * @param {number} fail
   * @param {number} zfail
   * @param {number} zpass
   */
  stencilOpSeparate(num face, num fail, num zfail, num zpass);

  /**
   * @param {number} target
   * @param {number} level
   * @param {number} internalformat
   * @param {number} format or width
   * @param {number} type or height
   * @param {ImageData|HTMLImageElement|HTMLCanvasElement|HTMLVideoElement|
   *     number} img or border
   * @param {number=} opt_format
   * @param {number=} opt_type
   * @param {ArrayBufferView=} opt_pixels
   */
  texImage2D(num target, num level, num internalformat, num format, num type,
      img /*html5.ImageData|null|w3c_dom2.HTMLImageElement|html5.HTMLCanvasElement|html5.HTMLVideoElement|num*/,
      [num opt_format, num opt_type, es6.ArrayBufferView opt_pixels]);

  /**
   * @param {number} target
   * @param {number} pname
   * @param {number} param
   */
  texParameterf(num target, num pname, num param);

  /**
   * @param {number} target
   * @param {number} pname
   * @param {number} param
   */
  texParameteri(num target, num pname, num param);

  /**
   * @param {number} target
   * @param {number} level
   * @param {number} xoffset
   * @param {number} yoffset
   * @param {number} format or width
   * @param {number} type or height
   * @param {ImageData|HTMLImageElement|HTMLCanvasElement|HTMLVideoElement|
   *     number} data or format
   * @param {number=} opt_type
   * @param {ArrayBufferView=} opt_pixels
   */
  texSubImage2D(num target, num level, num xoffset, num yoffset, num format,
      num type,
      data /*html5.ImageData|null|w3c_dom2.HTMLImageElement|html5.HTMLCanvasElement|html5.HTMLVideoElement|num*/,
      [num opt_type, es6.ArrayBufferView opt_pixels]);

  /**
   * @param {WebGLUniformLocation} location
   * @param {number} value
   */
  uniform1f(WebGLUniformLocation location, num value);

  /**
   * @param {WebGLUniformLocation} location
   * @param {Float32Array|Array.<number>} value
   */
  uniform1fv(
      WebGLUniformLocation location, value /*es6.Float32Array|null|List<num>*/);

  /**
   * @param {WebGLUniformLocation} location
   * @param {number} value
   */
  uniform1i(WebGLUniformLocation location, num value);

  /**
   * @param {WebGLUniformLocation} location
   * @param {Int32Array|Array.<number>} value
   */
  uniform1iv(
      WebGLUniformLocation location, value /*es6.Int32Array|null|List<num>*/);

  /**
   * @param {WebGLUniformLocation} location
   * @param {number} value1
   * @param {number} value2
   */
  uniform2f(WebGLUniformLocation location, num value1, num value2);

  /**
   * @param {WebGLUniformLocation} location
   * @param {Float32Array|Array.<number>} value
   */
  uniform2fv(
      WebGLUniformLocation location, value /*es6.Float32Array|null|List<num>*/);

  /**
   * @param {WebGLUniformLocation} location
   * @param {number} value1
   * @param {number} value2
   */
  uniform2i(WebGLUniformLocation location, num value1, num value2);

  /**
   * @param {WebGLUniformLocation} location
   * @param {Int32Array|Array.<number>} value
   */
  uniform2iv(
      WebGLUniformLocation location, value /*es6.Int32Array|null|List<num>*/);

  /**
   * @param {WebGLUniformLocation} location
   * @param {number} value1
   * @param {number} value2
   * @param {number} value3
   */
  uniform3f(WebGLUniformLocation location, num value1, num value2, num value3);

  /**
   * @param {WebGLUniformLocation} location
   * @param {Float32Array|Array.<number>} value
   */
  uniform3fv(
      WebGLUniformLocation location, value /*es6.Float32Array|null|List<num>*/);

  /**
   * @param {WebGLUniformLocation} location
   * @param {number} value1
   * @param {number} value2
   * @param {number} value3
   */
  uniform3i(WebGLUniformLocation location, num value1, num value2, num value3);

  /**
   * @param {WebGLUniformLocation} location
   * @param {Int32Array|Array.<number>} value
   */
  uniform3iv(
      WebGLUniformLocation location, value /*es6.Int32Array|null|List<num>*/);

  /**
   * @param {WebGLUniformLocation} location
   * @param {number} value1
   * @param {number} value2
   * @param {number} value3
   * @param {number} value4
   */
  uniform4f(WebGLUniformLocation location, num value1, num value2, num value3,
      num value4);

  /**
   * @param {WebGLUniformLocation} location
   * @param {Float32Array|Array.<number>} value
   */
  uniform4fv(
      WebGLUniformLocation location, value /*es6.Float32Array|null|List<num>*/);

  /**
   * @param {WebGLUniformLocation} location
   * @param {number} value1
   * @param {number} value2
   * @param {number} value3
   * @param {number} value4
   */
  uniform4i(WebGLUniformLocation location, num value1, num value2, num value3,
      num value4);

  /**
   * @param {WebGLUniformLocation} location
   * @param {Int32Array|Array.<number>} value
   */
  uniform4iv(
      WebGLUniformLocation location, value /*es6.Int32Array|null|List<num>*/);

  /**
   * @param {WebGLUniformLocation} location
   * @param {boolean} transpose
   * @param {Float32Array|Array.<number>} data
   */
  uniformMatrix2fv(WebGLUniformLocation location, bool transpose,
      data /*es6.Float32Array|null|List<num>*/);

  /**
   * @param {WebGLUniformLocation} location
   * @param {boolean} transpose
   * @param {Float32Array|Array.<number>} data
   */
  uniformMatrix3fv(WebGLUniformLocation location, bool transpose,
      data /*es6.Float32Array|null|List<num>*/);

  /**
   * @param {WebGLUniformLocation} location
   * @param {boolean} transpose
   * @param {Float32Array|Array.<number>} data
   */
  uniformMatrix4fv(WebGLUniformLocation location, bool transpose,
      data /*es6.Float32Array|null|List<num>*/);

  /**
   * @param {WebGLProgram} program
   */
  useProgram(WebGLProgram program);

  /**
   * @param {WebGLProgram} program
   */
  validateProgram(WebGLProgram program);

  /**
   * @param {number} indx
   * @param {number} x
   */
  vertexAttrib1f(num indx, num x);

  /**
   * @param {number} indx
   * @param {Float32Array|Array.<number>} values
   */
  vertexAttrib1fv(num indx, values /*es6.Float32Array|null|List<num>*/);

  /**
   * @param {number} indx
   * @param {number} x
   * @param {number} y
   */
  vertexAttrib2f(num indx, num x, num y);

  /**
   * @param {number} indx
   * @param {Float32Array|Array.<number>} values
   */
  vertexAttrib2fv(num indx, values /*es6.Float32Array|null|List<num>*/);

  /**
   * @param {number} indx
   * @param {number} x
   * @param {number} y
   * @param {number} z
   */
  vertexAttrib3f(num indx, num x, num y, num z);

  /**
   * @param {number} indx
   * @param {Float32Array|Array.<number>} values
   */
  vertexAttrib3fv(num indx, values /*es6.Float32Array|null|List<num>*/);

  /**
   * @param {number} indx
   * @param {number} x
   * @param {number} y
   * @param {number} z
   * @param {number} w
   */
  vertexAttrib4f(num indx, num x, num y, num z, num w);

  /**
   * @param {number} indx
   * @param {Float32Array|Array.<number>} values
   */
  vertexAttrib4fv(num indx, values /*es6.Float32Array|null|List<num>*/);

  /**
   * @param {number} indx
   * @param {number} size
   * @param {number} type
   * @param {boolean} normalized
   * @param {number} stride
   * @param {number} offset
   */
  vertexAttribPointer(
      num indx, num size, num type, bool normalized, num stride, num offset);

  /**
   * @param {number} x
   * @param {number} y
   * @param {number} width
   * @param {number} height
   */
  viewport(num x, num y, num width, num height);
}

/**
 * @constructor
 * @noalias
 */
@JsName("WebGLContextAttributes")
abstract class WebGLContextAttributes {
// @Ignore
  external WebGLContextAttributes.fakeConstructor$();

  /**
   * @type {boolean}
   */
  bool alpha;

  /**
   * @type {boolean}
   */
  bool depth;

  /**
   * @type {boolean}
   */
  bool stencil;

  /**
   * @type {boolean}
   */
  bool antialias;

  /**
   * @type {boolean}
   */
  bool premultipliedAlpha;

  /**
   * @type {boolean}
   */
  bool preserveDrawingBuffer;

  /**
   * @type {boolean}
   */
  bool preferLowPowerToHighPerformance;

  /**
   * @type {boolean}
   */
  bool failIfMajorPerformanceCaveat;
}

/**
 * @param {string} eventType
 * @constructor
 * @noalias
 * @extends {Event}
 */
@JsName("WebGLContextEvent")
abstract class WebGLContextEvent extends w3c_event.Event {
// @Ignore
  external WebGLContextEvent.fakeConstructor$() : super.fakeConstructor$();

  /**
   * @param {string} eventType
   * @constructor
   * @noalias
   * @extends {Event}
   */
  external factory WebGLContextEvent(String eventType);

  /**
   * @type {string}
   */
  String statusMessage;
}

/**
 * @constructor
 * @noalias
 */
@JsName("WebGLShaderPrecisionFormat")
abstract class WebGLShaderPrecisionFormat {
// @Ignore
  external WebGLShaderPrecisionFormat.fakeConstructor$();

  /**
   * @type {number}
   */
  num rangeMin;

  /**
   * @type {number}
   */
  num rangeMax;

  /**
   * @type {number}
   */
  num precision;
}

/**
 * @constructor
 * @noalias
 */
@JsName("WebGLObject")
abstract class WebGLObject {
// @Ignore
  external WebGLObject.fakeConstructor$();
}

/**
 * @constructor
 * @noalias
 * @extends {WebGLObject}
 */
@JsName("WebGLBuffer")
abstract class WebGLBuffer extends WebGLObject {
// @Ignore
  external WebGLBuffer.fakeConstructor$() : super.fakeConstructor$();
}

/**
 * @constructor
 * @noalias
 * @extends {WebGLObject}
 */
@JsName("WebGLFramebuffer")
abstract class WebGLFramebuffer extends WebGLObject {
// @Ignore
  external WebGLFramebuffer.fakeConstructor$() : super.fakeConstructor$();
}

/**
 * @constructor
 * @noalias
 * @extends {WebGLObject}
 */
@JsName("WebGLProgram")
abstract class WebGLProgram extends WebGLObject {
// @Ignore
  external WebGLProgram.fakeConstructor$() : super.fakeConstructor$();
}

/**
 * @constructor
 * @noalias
 * @extends {WebGLObject}
 */
@JsName("WebGLRenderbuffer")
abstract class WebGLRenderbuffer extends WebGLObject {
// @Ignore
  external WebGLRenderbuffer.fakeConstructor$() : super.fakeConstructor$();
}

/**
 * @constructor
 * @noalias
 * @extends {WebGLObject}
 */
@JsName("WebGLShader")
abstract class WebGLShader extends WebGLObject {
// @Ignore
  external WebGLShader.fakeConstructor$() : super.fakeConstructor$();
}

/**
 * @constructor
 * @noalias
 * @extends {WebGLObject}
 */
@JsName("WebGLTexture")
abstract class WebGLTexture extends WebGLObject {
// @Ignore
  external WebGLTexture.fakeConstructor$() : super.fakeConstructor$();
}

/**
 * @constructor
 * @noalias
 */
@JsName("WebGLActiveInfo")
abstract class WebGLActiveInfo {
// @Ignore
  external WebGLActiveInfo.fakeConstructor$();

  /** @type {number} */
  num size;

  /** @type {number} */
  num type;

  /** @type {string} */
  String name;
}

/**
 * @constructor
 * @noalias
 */
@JsName("WebGLUniformLocation")
abstract class WebGLUniformLocation {
// @Ignore
  external WebGLUniformLocation.fakeConstructor$();
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/OES_texture_float/
 * @constructor
 * @noalias
 */
@JsName("OES_texture_float")
abstract class OES_texture_float {
// @Ignore
  external OES_texture_float.fakeConstructor$();
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/OES_texture_half_float/
 * @constructor
 * @noalias
 */
@JsName("OES_texture_half_float")
abstract class OES_texture_half_float {
// @Ignore
  external OES_texture_half_float.fakeConstructor$();

  /** @type {number} */
  num HALF_FLOAT_OES;
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/WEBGL_lose_context/
 * @constructor
 * @noalias
 */
@JsName("WEBGL_lose_context")
abstract class WEBGL_lose_context {
// @Ignore
  external WEBGL_lose_context.fakeConstructor$();

  loseContext();

  restoreContext();
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/OES_standard_derivatives/
 * @constructor
 * @noalias
 */
@JsName("OES_standard_derivatives")
abstract class OES_standard_derivatives {
// @Ignore
  external OES_standard_derivatives.fakeConstructor$();

  /** @type {number} */
  num FRAGMENT_SHADER_DERIVATIVE_HINT_OES;
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/OES_vertex_array_object/
 * @constructor
 * @noalias
 * @extends {WebGLObject}
 */
@JsName("WebGLVertexArrayObjectOES")
abstract class WebGLVertexArrayObjectOES extends WebGLObject {
// @Ignore
  external WebGLVertexArrayObjectOES.fakeConstructor$()
      : super.fakeConstructor$();
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/OES_vertex_array_object/
 * @constructor
 * @noalias
 */
@JsName("OES_vertex_array_object")
abstract class OES_vertex_array_object {
// @Ignore
  external OES_vertex_array_object.fakeConstructor$();

  /** @type {number} */
  num VERTEX_ARRAY_BINDING_OES;

  /**
   * @return {WebGLVertexArrayObjectOES}
   * @nosideeffects
   */
  WebGLVertexArrayObjectOES createVertexArrayOES();

  /**
   * @param {WebGLVertexArrayObjectOES} arrayObject
   */
  deleteVertexArrayOES(WebGLVertexArrayObjectOES arrayObject);

  /**
   * @param {WebGLVertexArrayObjectOES} arrayObject
   * @return {boolean}
   * @nosideeffects
   */
  bool isVertexArrayOES(WebGLVertexArrayObjectOES arrayObject);

  /**
   * @param {WebGLVertexArrayObjectOES} arrayObject
   */
  bindVertexArrayOES(WebGLVertexArrayObjectOES arrayObject);
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/WEBGL_debug_renderer_info/
 * @constructor
 * @noalias
 */
@JsName("WEBGL_debug_renderer_info")
abstract class WEBGL_debug_renderer_info {
// @Ignore
  external WEBGL_debug_renderer_info.fakeConstructor$();

  /** @type {number} */
  num UNMASKED_VENDOR_WEBGL;

  /** @type {number} */
  num UNMASKED_RENDERER_WEBGL;
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/WEBGL_debug_shaders/
 * @constructor
 * @noalias
 */
@JsName("WEBGL_debug_shaders")
abstract class WEBGL_debug_shaders {
// @Ignore
  external WEBGL_debug_shaders.fakeConstructor$();

  /**
   * @param {WebGLShader} shader
   * @return {string}
   * @nosideeffects
   */
  String getTranslatedShaderSource(WebGLShader shader);
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/WEBGL_compressed_texture_s3tc/
 * @constructor
 * @noalias
 */
@JsName("WEBGL_compressed_texture_s3tc")
abstract class WEBGL_compressed_texture_s3tc {
// @Ignore
  external WEBGL_compressed_texture_s3tc.fakeConstructor$();

  /** @type {number} */
  num COMPRESSED_RGB_S3TC_DXT1_EXT;

  /** @type {number} */
  num COMPRESSED_RGBA_S3TC_DXT1_EXT;

  /** @type {number} */
  num COMPRESSED_RGBA_S3TC_DXT3_EXT;

  /** @type {number} */
  num COMPRESSED_RGBA_S3TC_DXT5_EXT;
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/OES_depth_texture/
 * @constructor
 * @noalias
 */
@JsName("OES_depth_texture")
abstract class OES_depth_texture {
// @Ignore
  external OES_depth_texture.fakeConstructor$();
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/OES_element_index_uint/
 * @constructor
 * @noalias
 */
@JsName("OES_element_index_uint")
abstract class OES_element_index_uint {
// @Ignore
  external OES_element_index_uint.fakeConstructor$();
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/EXT_texture_filter_anisotropic/
 * @constructor
 * @noalias
 */
@JsName("EXT_texture_filter_anisotropic")
abstract class EXT_texture_filter_anisotropic {
// @Ignore
  external EXT_texture_filter_anisotropic.fakeConstructor$();

  /** @type {number} */
  num TEXTURE_MAX_ANISOTROPY_EXT;

  /** @type {number} */
  num MAX_TEXTURE_MAX_ANISOTROPY_EXT;
}

/**
 * @see http://www.khronos.org/registry/webgl/extensions/ANGLE_instanced_arrays/
 * @constructor
 * @noalias
 */
@JsName("ANGLE_instanced_arrays")
abstract class ANGLE_instanced_arrays {
// @Ignore
  external ANGLE_instanced_arrays.fakeConstructor$();

  /** @type {number} */
  num VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE;

  /**
   * @param {number} mode Primitive type.
   * @param {number} first First vertex.
   * @param {number} count Number of vertices per instance.
   * @param {number} primcount Number of instances.
   */
  drawArraysInstancedANGLE(num mode, num first, num count, num primcount);

  /**
   * @param {number} mode Primitive type.
   * @param {number} count Number of vertex indices per instance.
   * @param {number} type Type of a vertex index.
   * @param {number} offset Offset to the first vertex index.
   * @param {number} primcount Number of instances.
   */
  drawElementsInstancedANGLE(
      num mode, num count, num type, num offset, num primcount);

  /**
   * @param {number} index Attribute index.
   * @param {number} divisor Instance divisor.
   */
  vertexAttribDivisorANGLE(num index, num divisor);
}
