/*
 * Copyright 2009 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview Definitions for W3C's WebStorage specification.
 * This file depends on html5.js.
 * FROM_EXTERN
 */
@JsName()
library webstorage;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "w3c_event.dart" as w3c_event;

/**
 * @interface
 * @see http://www.w3.org/TR/2011/CR-webstorage-20111208/#the-storage-interface
 */
@JsName("Storage")
abstract class Storage {
// @Ignore
  external Storage.fakeConstructor$();

  /**
   * @type {number}
   * @const
   */
  num length;

  /**
   * @param {number} index
   * @return {?string}
   */
  String key(num index);

  /**
   * @param {string} key
   * @return {?string}
   */
  String getItem(String key);

  /**
   * @param {string} key
   * @param {string} data
   * @return {void}
   */
  void setItem(String key, String data);

  /**
   * @param {string} key
   * @return {void}
   */
  void removeItem(String key);

  /**
   * @return {void}
   */
  void clear();
}

/**
 * @interface
 * @see http://www.w3.org/TR/2011/CR-webstorage-20111208/#the-sessionstorage-attribute
 */
@JsName("WindowSessionStorage")
abstract class WindowSessionStorage {
// @Ignore
  external WindowSessionStorage.fakeConstructor$();

  /**
   * @type {Storage}
   */
  Storage sessionStorage;
}

/**
 * @interface
 * @see http://www.w3.org/TR/2011/CR-webstorage-20111208/#the-localstorage-attribute
 */
@JsName("WindowLocalStorage")
abstract class WindowLocalStorage {
// @Ignore
  external WindowLocalStorage.fakeConstructor$();

  /**
   * @type {Storage}
   */
  Storage localStorage;
}

/**
 * This is the storage event interface.
 * @see http://www.w3.org/TR/2011/CR-webstorage-20111208/#the-storage-event
 * @extends {Event}
 * @constructor
 */
@JsName("StorageEvent")
abstract class StorageEvent extends w3c_event.Event {
// @Ignore
  external StorageEvent.fakeConstructor$() : super.fakeConstructor$();

  /**
   * @type {string}
   */
  String key;

  /**
   * @type {?string}
   */
  String oldValue;

  /**
   * @type {?string}
   */
  String newValue;

  /**
   * @type {string}
   */
  String url;

  /**
   * @type {?Storage}
   */
  Storage storageArea;

  /**
   * @param {string} typeArg
   * @param {boolean} canBubbleArg
   * @param {boolean} cancelableArg
   * @param {string} keyArg
   * @param {?string} oldValueArg
   * @param {?string} newValueArg
   * @param {string} urlArg
   * @param {?Storage} storageAreaArg
   * @return {void}
   */
  void initStorageEvent(String typeArg, bool canBubbleArg, bool cancelableArg,
      String keyArg, String oldValueArg, String newValueArg, String urlArg,
      Storage storageAreaArg);
}
