/*
 * Copyright 2008 The Closure Compiler Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// This file has been automatically generated.  Please do not edit it manually.
/**
 * @fileoverview JavaScript Built-Ins for windows properties.
 *
 * FROM_EXTERN
 * @author stevey@google.com (Steve Yegge)
 */
@JsName()
library window;

import 'package:js/js.dart';
import 'package:func/func.dart';

import "gecko_dom.dart" as gecko_dom;

import "ie_dom.dart" as ie_dom;

import "w3c_css.dart" as w3c_css;

import "w3c_dom1.dart" as w3c_dom1;

import "w3c_dom2.dart" as w3c_dom2;

/**
 * @type {!Window}
 * @see https://developer.mozilla.org/en/DOM/window.top
 * @const
 */
@JsName("top")
external w3c_dom1.Window get top;
/**
 * @type {Navigator}
 * @see https://developer.mozilla.org/en/DOM/window.navigator
 * @const
 */
@JsName("navigator")
external gecko_dom.Navigator get navigator;
/**
 * @type {!HTMLDocument}
 * @see https://developer.mozilla.org/en/DOM/window.document
 * @const
 */
@JsName("document")
external w3c_dom2.HTMLDocument get document;
/**
 * @type {Location}
 * @see https://developer.mozilla.org/en/DOM/window.location
 * @const
 * @suppress {duplicate}
 * @implicitCast
 */
@JsName("location")
external ie_dom.Location get location;
/**
 * @type {!Screen}
 * @see https://developer.mozilla.org/En/DOM/window.screen
 * @const
 */
@JsName("screen")
external w3c_css.Screen get screen;
/**
 * @type {!Window}
 * @see https://developer.mozilla.org/En/DOM/Window.self
 * @const
 */
@JsName("self")
external w3c_dom1.Window get self;
/**
 * @see https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/JavaArray
 */
@JsName("JavaArray")
external dynamic get JavaArray;
@JsName("JavaArray")
external set JavaArray(dynamic value);
/**
 * @see https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/JavaClass
 */
@JsName("JavaClass")
external dynamic get JavaClass;
@JsName("JavaClass")
external set JavaClass(dynamic value);
@JsName("JavaMember")
external dynamic get JavaMember;
@JsName("JavaMember")
external set JavaMember(dynamic value);
/**
 * @see https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/JavaObject
 */
@JsName("JavaObject")
external dynamic get JavaObject;
@JsName("JavaObject")
external set JavaObject(dynamic value);
/**
 * @see https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/JavaPackage
 */
@JsName("JavaPackage")
external dynamic get JavaPackage;
@JsName("JavaPackage")
external set JavaPackage(dynamic value);
/**
 * @see https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Packages
 */
@JsName("Packages")
external dynamic get Packages;
@JsName("Packages")
external set Packages(dynamic value);
/**
 * @see https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/java
 */
@JsName("java")
external dynamic get java;
@JsName("java")
external set java(dynamic value);
/**
 * @see https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/netscape
 */
@JsName("netscape")
external dynamic get netscape;
@JsName("netscape")
external set netscape(dynamic value);
/**
 * @see https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/sun
 */
@JsName("sun")
external dynamic get sun;
@JsName("sun")
external set sun(dynamic value);
/**
 * @see https://developer.mozilla.org/en/DOM/window.alert
 */
external alert(x);
/**
 * @param {number|undefined|null} immediateID
 * @see https://developer.mozilla.org/en-US/docs/DOM/window.clearImmediate
 * @see http://msdn.microsoft.com/en-us/library/ie/hh924825(v=vs.85).aspx
 */
external clearImmediate(num immediateID);
/**
 * @param {number|undefined?} intervalID
 * @see https://developer.mozilla.org/en/DOM/window.clearInterval
 * @suppress {duplicate}
 */
external clearInterval(num intervalID);
/**
 * @param {number|undefined?} timeoutID
 * @see https://developer.mozilla.org/en/DOM/window.clearTimeout
 * @suppress {duplicate}
 */
external clearTimeout(num timeoutID);
/**
 * @param {*} message
 * @return {boolean}
 * @see https://developer.mozilla.org/en/DOM/window.confirm
 */
external bool confirm(message);
/**
 * @see https://developer.mozilla.org/en/DOM/window.dump
 */
external dump(x);
/**
 * @param {string} message
 * @param {string=} opt_value
 * @return {?string}
 * @see https://developer.mozilla.org/en/DOM/window.prompt
 */
external String prompt(String message, [String opt_value]);
/**
 * @param {function()} callback
 * @return {number}
 * @see https://developer.mozilla.org/en-US/docs/DOM/window.setImmediate
 * @see http://msdn.microsoft.com/en-us/library/ie/hh773176(v=vs.85).aspx
 */
external num setImmediate(callback());
/**
 * @param {Function|string} callback
 * @param {number=} opt_delay
 * @return {number}
 * @see https://developer.mozilla.org/en/DOM/window.setInterval
 * @see https://html.spec.whatwg.org/multipage/webappapis.html#timers
 */
external num setInterval(callback /*Function|null|String*/, [num opt_delay]);
/**
 * @param {Function|string} callback
 * @param {number=} opt_delay
 * @param {...*} var_args
 * @return {number}
 * @see https://developer.mozilla.org/en/DOM/window.setTimeout
 * @see https://html.spec.whatwg.org/multipage/webappapis.html#timers
 */
external num setTimeout(callback /*Function|null|String*/,
    [num opt_delay, var_args1, var_args2, var_args3, var_args4]);
